;**********************************************************************
; library of Graphics Universal Interface for Kolibri operation system
;
; version 1.0
; 2007 year
;**********************************************************************

format MS COFF

public EXPORTS

section '.flat' code readable align 16


;****************************************************
;******************Crate Button**********************
;****************************************************
;IN
;pointer to parend
;pointer to Buttton's structure
;OUT
;pointer to initialized Button's structure
align 4

crate_button:

      pop [ReturnAddresButton]
      pop eax
      pop ebx

      mov [PointerToStructureForButton],eax

      mov eax,44+50
      call crate_control

      ;set all button's parameters in control
      mov ecx,button
      mov [eax],dword button

      mov ecx,50
      mov esi,[PointerToStructureForButton]
      mov edi,eax
      add edi,44
      rep movsb

      mov ebx,[PointerToStructureForButton]
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov cx,[ebx+2]   ;button x
      mov dx,[ebx+4]   ;button y
      mov si,[ebx+6]   ;button size x
      mov di,[ebx+8]   ;button size y
      ;copy information to control
      mov [eax+24],ecx
      mov [eax+28],edx
      mov [eax+32],esi
      mov [eax+36],edi

      ;return pointer to control of button
      push eax
      push [ReturnAddresButton]

      ret

;****************************************************
;*******************Draw Button**********************
;****************************************************
;IN
;pointer to control of button
;message
;OUT
;not returned value
align 4

button:

      ;get message
      mov eax,[esp+8]

      ;get pointer to control of button
      mov esi,[esp+4]
      mov [PointerForButton],esi
      ;copy control to local control
      mov edi,Button
      mov ecx,44+50
      cld
      rep movsb


      cmp [eax],dword 1
      jne no_redraw_all_button

      or [Button.type],10000000b
      no_redraw_all_button:

      cmp [eax],dword 2
      jne no_keys_button

      jmp exit_button
      no_keys_button:

      cmp [eax],dword 3
      jne no_pressed_button_button

      jmp exit_button
      no_pressed_button_button:

      cmp [eax],dword 6
      jne no_mouse_button

      mov esi,[eax+4]
      mov edi,[eax+8]
      mov ecx,[eax+12]
      mov [Button.mouseX],si
      mov [Button.mouseY],di
      mov [ButtonsOfMouse],ecx

      no_mouse_button:


      cmp [eax],dword -1
      jne no_delete_button

      jmp exit_button
      no_delete_button:


      ;load coordinats and size from control
      mov eax,[PointerForButton]
      mov ebx,[eax+24]		 ;x
      mov ecx,[eax+28]		 ;y
      mov edx,[eax+32]		 ;size x
      mov esi,[eax+36]		 ;size y
      ;set current coordinats and sizes in zakladka
      mov [Button.x],bx
      mov [Button.y],cx
      mov [Button.width],dx
      mov [Button.height],si


      mov [Button.color2],0xffffff

      xor eax,eax
      mov al,[Button.type]
      and al,10000000b
      test al,al
      jz  no_redraw_button

      and [Button.type],1111111b

      mov esi,Button
      mov edi,[PointerForButton]
      add esi,44
      add edi,44
      mov ecx,2
      cld
      rep movsb

      ;if bit 3 is tru than no draw button
      mov al,[Button.type]
      and al,1000b
      test al,al
      jnz  no_draw_button

      ;generate colors tables
      mov eax,[Button.color1]
      mov ebx,0xffffff
      mov ecx,20
      mov edx,colors_table1
      call gradient

      xor eax,eax
      mov ebx,[Button.color1]
      mov ecx,20
      mov edx,colors_table2
      call gradient

      xor eax,eax
      mov al,[Button.type]

      and al,10000b
      test al,al
      jz no_3d_button

      ;draw gradient up rectangle
      mov eax,[Button.color1]
      mov ebx,[Button.color2]
      and eax,0xffffff
      and ebx,0xffffff
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov cx,[Button.x]
      mov dx,[Button.y]
      mov si,[Button.width]
      mov di,[Button.height]
      add cx,1
      add dx,2
      sub si,1
      sub di,3
      call rectangle_gradient_up

      ;draw left vertical line
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov edx,[Button.color1]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y1],3
      add [Line.y2],ecx
      call DrawLine

      ;draw right vertical line
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      mov edx,[Button.color1]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y1],3
      add [Line.y2],ecx
      call DrawLine

      ;draw down 1 horizontal line
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      mov edx,[Button.color1]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.x1],1
      sub esi,1
      add [Line.x2],esi
      call DrawLine

      ;draw up light horizontal rectangle
      xor ecx,ecx
      xor esi,esi
      mov si,[Button.height]
      mov di,[Button.width]
      mov eax,13
      mov bx,[Button.x]
      mov cx,[Button.y]
      mov edx,0xffffff
      add ebx,2
      add ecx,1
      shl ebx,16
      shl ecx,16
      sub edi,3
      add ebx,edi
      add ecx,2
      int 0x40

      ;draw left light vertical line
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]

      ;calculate color
      mov dx,[Button.height]
      sub edx,3+2
      mov esi,[pointer+edx*3]
      and esi,0xffffff
      add eax,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],esi; dword 0xffffff
      add [Line.y1],2
      sub ecx,3
      add [Line.y2],ecx
      call DrawLine

      ;draw right light vertical line
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      ;calculate color
      mov dx,[Button.height]
      sub edx,3+2
      mov esi,[pointer+edx*3]
      and esi,0xffffff

      add ax,[Button.width]
      sub eax,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],esi ;dword 0xffffff
      add [Line.y1],2
      sub ecx,3
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      mov eax,[pointer+3*3]
      and eax,0xffffff
      mov [Button.color2],eax

      ;draw up light left vertical line 1
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      mov edx,[Button.color2]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],2
      call DrawLine

      ;draw up light right vertical line 1
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      mov edx,[Button.color2]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],2
      call DrawLine

      ;draw up light left vertical line 2
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      mov edx,[Button.color2]
      add eax,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],1
      call DrawLine

      ;draw up light right vertical line 2
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      mov edx,[Button.color2]
      add eax,esi
      sub eax,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],1
      call DrawLine

      ;draw up light horizontal line
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      mov edx,[Button.color2]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.x1],2
      sub esi,2
      add [Line.x2],esi
      call DrawLine

      xor eax,eax
      mov eax,[pointer+3*3]
      and eax,0xffffff
      mov ebx,0xffffff
      call calculate_average_color

      mov [Pixel.color],eax

      ;(x,y)
      xor eax,eax
      xor ebx,ebx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;(x+size_x,y)
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.width]
      add eax,ecx
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;(x+1,y+1)
      xor eax,eax
      xor ebx,ebx
      mov ax,[Button.x]
      mov bx,[Button.y]
      add eax,1
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;(x+size_x-1,y+1)
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.width]
      add eax,ecx
      sub eax,1
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;(x,y+size_y)
      xor eax,eax
      xor ebx,ebx
      mov ax,[Button.x]
      mov bx,[Button.y]
      add bx,[Button.height]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;(x+size_x,y+size_y)
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.width]
      add eax,ecx
      add bx,[Button.height]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;(x+1,y+size_y-2)
      xor eax,eax
      xor ebx,ebx
      mov ax,[Button.x]
      mov bx,[Button.y]
      add eax,1
      add bx,[Button.height]
      sub ebx,2
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;(x+size_x-1,y+size_y-2)
      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.width]
      add eax,ecx
      sub eax,1
      add bx,[Button.height]
      sub ebx,2
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      no_3d_button:

      ;****************************
      ;*********2D button**********
      ;****************************
      xor eax,eax
      mov al,[Button.type]
      and al,10000b
      test al,al
      jnz no_2D_button

      mov edx,[colors_table1+18]
      and edx,0xffffff

      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      xor edi,edi
      mov si,[Button.width]
      mov di,[Button.height]
      mov eax,13
      mov bx,[Button.x]
      mov cx,[Button.y]
      add ebx,1
      add ecx,1
      sub si,1
      sub di,1
      shl ebx,16
      shl ecx,16
      add ebx,esi
      add ecx,edi
      int 0x40

      mov edx,[colors_table1+15*3]
      and edx,0xffffff

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      ;xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      ;mov si,[Button.width]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      ;xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      ;mov cx,[Button.height]
      mov si,[Button.width]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.x2],esi
      call DrawLine

      mov edx,[colors_table2+8*3]
      and edx,0xffffff

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.x2],esi
      call DrawLine

      no_2D_button:

      no_draw_button:

      ;check drawing text on the button
      xor eax,eax
      mov al,[Button.type]

      and al,1b
      test al,al
      jz no_button_only_with_text

       call DrawStringOnTheButton
       jmp end_case_button
      no_button_only_with_text:

      ;check drawing picture on the button
      xor eax,eax
      mov al,[Button.type]
      and al,10b
      test al,al
      jz no_button_only_with_picture

	call DrawPictureOnTheButton
	jmp end_case_button
      no_button_only_with_picture:


      xor eax,eax
      mov al,[Button.type]
      and al,100b
      test al,al
      jz no_button_with_text_and_picture

      ;draw string in coordinats (textX,textY)
      xor eax,eax
      xor ebx,ebx
      mov ax,[Button.textX]
      mov bx,[Button.textY]
      add ax,[Button.x]
      add bx,[Button.y]
      mov [Font.x],eax
      mov [Font.y],ebx
      call DrawString

      ;draw picture in coordinats (imageX,imageY)
      xor eax,eax
      xor ebx,ebx
      mov ax,[Button.imageX]
      mov bx,[Button.imageY]
      add ax,[Button.x]
      add bx,[Button.y]
      mov [xo],eax
      mov [x],eax
      mov [y],ebx

      xor esi,esi
      xor edi,edi
      mov si,[Button.imageSizeX]
      mov di,[Button.imageSizeY]
      mov ebp,[Button.image]

      xor eax,eax
      inc eax

	loop_y_image_:

	  mov ebx,[xo]
	  mov [x],ebx

	  xor esi,esi
	  mov si,[Button.imageSizeX]

	  loop_x_image_:

	     mov edx,[ebp]
	     and edx,0xffffff
	     cmp edx,[Button.transparentColor]
	     je no_draw_pixel_

	       mov ebx,[x]
	       mov ecx,[y]
	       int 0x40
	     no_draw_pixel_:

	     add ebp,3
	     add [x],1
	  dec esi
	  jnz  loop_x_image_

	  add [y],1
	dec edi
	jnz loop_y_image_

      no_button_with_text_and_picture:

      no_redraw_button:

      end_case_button:

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.width]
      mov dx,[Button.height]
      mov si,[Button.mouseX]
      mov di,[Button.mouseY]
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing

	xor ebx,ebx
	mov bl,[Button.type]
	and bl,10000b
	test bl,bl
	jz button_active_2D

	 push eax
	   mov eax,[ButtonsOfMouse]

	   cmp eax,1
	   je button_pressed_3d_

	     xor eax,eax
	     mov al,[Button.type]
	     and al,1000b
	     test al,al
	     jnz no_draw_active_button_3d_

	       call Draw3DActiveButton

	     no_draw_active_button_3d_:

	   jmp exit_button_pressed_3d_

	   button_pressed_3d_:

	   xor eax,eax
	   mov al,[Button.type]
	   and al,1000b
	   test al,al
	   jnz no_draw_pressed_button_3d_

	    call DrawPressed3DButton

	   no_draw_pressed_button_3d_:

	   or [Button.flag],byte 10b
	   exit_button_pressed_3d_:

	 pop eax
	 or [Button.flag],byte 1b
	 ;save flag
	 mov esi,Button
	 mov edi,[PointerForButton]
	 add esi,44
	 add edi,44
	 mov ecx,2
	 cld
	 rep movsb
	 jmp no_crossing

	button_active_2D:

	 push eax
	   mov eax,[ButtonsOfMouse]

	   cmp eax,1
	   je button_pressed_2d

	   xor eax,eax
	   mov al,[Button.type]
	   and al,1000b
	   test al,al
	   jnz no_active_button_2d_

	    call Draw2DActiveButton

	   no_active_button_2d_:

	   jmp exit_button_pressed_2d
	   button_pressed_2d:

	   xor eax,eax
	   mov al,[Button.type]
	   and al,1000b
	   test al,al
	   jnz no_draw_pressed_button_2d_

	    call DrawPressed2DButton

	   no_draw_pressed_button_2d_:

	   or [Button.flag],byte 10b
	   exit_button_pressed_2d:
	 pop eax
	 or [Button.flag],byte 1b
	 ;save flag
	 mov esi,Button
	 mov edi,[PointerForButton]
	 add esi,44
	 add edi,44
	 mov ecx,2
	 cld
	 rep movsb
      no_crossing:

      cmp eax,0xffffff
      je yes_crossing
      xor ebx,ebx
      mov bl,[Button.flag]
      and bl,1b
      test bl,bl
      jz yes_crossing

	xor ebx,ebx
	mov bl,[Button.type]
	and bl,10000b
	test bl,bl
	jz button_put_2D

	 push eax

	 xor eax,eax
	 mov al,[Button.type]
	 and al,1000b
	 test al,al
	 jnz no_draw_button_active_3d__

	  call Put3DActiveButton
	 no_draw_button_active_3d__:

	 pop eax

	 and [Button.flag],11111110b
	 mov esi,Button
	 mov edi,[PointerForButton]
	 add edi,44
	 add esi,44
	 mov ecx,2
	 cld
	 rep movsb
	 jmp yes_crossing

	button_put_2D:

	push eax

	xor eax,eax
	mov al,[Button.type]
	and al,1000b
	test al,al
	jnz no_draw_button_active_2d__

	 call Put2DActiveButton

	no_draw_button_active_2d__:

	pop eax

	and [Button.flag],11111110b
	mov esi,Button
	mov edi,[PointerForButton]
	add esi,44
	add edi,44
	mov ecx,2
	cld
	rep movsb
      yes_crossing:

      exit_button:

      ret 8

;****************************************************
;******************Crate Scroler*********************
;****************************************************
;IN
;pointer to parend
;pointer to Scroler's structure
;OUT
;pointer to initialized Scroler's structure
align 4

crate_scroler:

      pop [ReturnAddresScroler]
      pop eax
      pop ebx

      mov [PointerToStructureForScroler],eax

      mov eax,44+23
      call crate_control

     ;set all button's parameters in control
      mov [eax],dword scroler

      mov ecx,23
      mov esi,[PointerToStructureForScroler]
      mov edi,eax
      add edi,44
      rep movsb

      mov ebx,[PointerToStructureForScroler]

      xor ecx,ecx
      mov cl,byte[ebx]
      and cl,1b
      jz type_horizontal_scroler

      ;if we here than scroler vertical
      mov esi,16	 ;scroler size x
      xor edi,edi
      mov di,[ebx+5]	;scroler size y
      jmp exit_type_scroler
      type_horizontal_scroler:

      xor esi,esi
      mov si,[ebx+5]	;scroler size x
      mov edi,16	;scroler size y
      exit_type_scroler:

      xor ecx,ecx
      xor edx,edx
      mov cx,[ebx+1]	;scroler x
      mov dx,[ebx+3]	;scroler y
      ;copy information to control
      mov [eax+24],ecx
      mov [eax+28],edx
      mov [eax+32],esi
      mov [eax+36],edi

      ;return pointer to control of button
      push eax
      push [ReturnAddresScroler]

      ret

;****************************************************
;*******************Draw Scroler*********************
;****************************************************
;IN
;pointer to control of scroler
;message
;OUT
;not returned value
align 4

scroler:


      ;get message
      mov eax,[esp+8]

      ;get pointer to control of scroler
      mov esi,[esp+4]
      mov [PointerForScroler],esi
      ;copy control to local control
      mov edi,Scroler
      mov ecx,44+23
      rep movsb


      cmp [eax],dword 1
      jne no_redraw_all_scroler

      or [Scroler.type],11100000b
      no_redraw_all_scroler:

      cmp [eax],dword 2
      jne no_keys_scroler

      jmp exit_scroler
      no_keys_scroler:

      cmp [eax],dword 3
      jne no_pressed_button_scroler

      jmp exit_scroler
      no_pressed_button_scroler:

      cmp [eax],dword 6
      jne no_mouse_scroler

      mov esi,[eax+4]
      mov edi,[eax+8]
      mov ecx,[eax+12]
      mov [Scroler.mouseX],si
      mov [Scroler.mouseY],di
      mov [ButtonsOfMouse],ecx
      no_mouse_scroler:


      cmp [eax],dword -1
      jne no_delete_scroler

      jmp exit_scroler
      no_delete_scroler:

      ;load coordinats and size from control
      mov eax,[PointerForScroler]
      mov ebx,[eax+24]		 ;x
      mov ecx,[eax+28]		 ;y
      ;mov edx,[eax+32]           ;size x
      ;mov esi,[eax+36]           ;size y
      ;set current coordinats and sizes in scroler
      mov [Scroler.x],bx
      mov [Scroler.y],cx


      ;is a 3D scroler ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,10000b
      test al,al
      jz no_3D_scroler

      ;mov eax,-1
      ;int 0x40

      mov eax,[Scroler.color1]
      mov ebx,0xffffff
      mov ecx,16
      mov edx,pointer
      call gradient

      mov eax,[pointer+9]
      and eax,0xffffff
      mov [Color],eax

      mov eax,[pointer]
      mov ebx,0xffffff
      call calculate_average_color
      mov [AveregeColor],eax

      ;is a vertical 3D scroler ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,1b
      test al,al
      jz no_vertical_scroler_3D

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov cx,16
      mov dx,[Scroler.length]
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add ebx,17
      sub edx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_vertical_scroler_3D

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      no_crossing_vertical_scroler_3D:

      ;is a vertical 3D scroler active ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_vertical_scroler_active

      ;calculate size of scroll bar
      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16+16
      mov [v],eax
      fld [Scroler.size]
      fild [v]
      fmul st0,st1
      fistp [ScrolerSize]
      fstp [v]

      cmp [ScrolerSize],4
      jae no_minimum_size_vertical_3D_scroler

	mov [ScrolerSize],4
      no_minimum_size_vertical_3D_scroler:

      ;if scroler is not active than use this is coordinats.
      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,17+17
      sub eax,[ScrolerSize]
      mov [yo],eax
      fld [Scroler.pos]
      fild [yo]
      fmul st0,st1
      fistp [v]
      fstp [v2]

      xor eax,eax
      mov ax,[Scroler.y]
      add ax,17
      add eax,[v]
      mov [ScrollBar.y],eax

      ;check button of mouse
      mov eax,[ButtonsOfMouse]
      and eax,1b
      test al,al
      jz no_vertical_scroler_move
      ;calculate in pixels length of scroll bar

      xor eax,eax
      xor edx,edx
      xor ecx,ecx
      mov ax,[Scroler.y]
      mov cx,[Scroler.length]
      mov dx,[Scroler.mouseY]
      mov ebx,edx
      add ecx,eax
      add eax,17
      sub ecx,17
      mov esi,ecx

      sub ebx,eax
      jns no_minimum_scroler_y

      mov [Scroler.mouseY],ax
      no_minimum_scroler_y:

      sub ecx,edx
      jns no_maximum_scroler_y

      mov [Scroler.mouseY],si
      no_maximum_scroler_y:


      mov eax,[ScrolerSize]
      shr eax,1
      xor ebx,ebx
      mov bx,[Scroler.mouseY]
      sub bx,[Scroler.y]
      sub ebx,17
      xor ecx,ecx
      mov cx,[Scroler.y]
      add cx,[Scroler.length]
      sub cx,17
      sub cx,[Scroler.mouseY]

      cmp ebx,eax
      jae no_correct_y
       xor edx,edx
       mov dx,[Scroler.y]
       add dx,17
       add edx,eax
      no_correct_y:

      cmp ecx,eax
      jae no_correct_y_
       xor edx,edx
       mov dx,[Scroler.y]
       add dx,[Scroler.length]
       sub dx,17
       sub edx,eax
      no_correct_y_:

      mov [ScrollBar.y],edx
      sub [ScrollBar.y],eax
      sub dx,[Scroler.y]
      sub edx,17
      sub edx,eax
      mov [v],edx

      shl eax,1
      xor ebx,ebx
      mov bx,[Scroler.length]
      sub ebx,17+17
      sub ebx,[ScrolerSize]
      mov [v2],ebx

      fild [v2]
      fild [v]
      fdiv st0,st1
      fstp [Scroler.pos]
      fistp [v2]

      ;put 5 bit(scroll bar move)
      or [Scroler.type],100000b

      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp no_vertical_scroler_active
      no_vertical_scroler_move:

      no_vertical_scroler_active:

      ;if bit 7 is a true than redraw all scroler.

      xor eax,eax
      mov al,[Scroler.type]
      and al,10000000b
      test al,al
      jz no_redraw_all_vertical_scroler

      and [Scroler.type],01111111b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      ;draw vertical up rectangle
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Rectangle.x],eax
      mov [Rectangle.y],ebx
      mov [Rectangle.width],16
      mov [Rectangle.height],16

      mov eax,[pointer]
      and eax,0xffffff
      mov [Rectangle.color],eax
      call RectangleContour

      ;draw gradient right
      mov eax,[Scroler.color1]
      mov ebx,dword 0xffffff
      and eax,0xffffff
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov cx,[Scroler.x]
      mov dx,[Scroler.y]
      mov si,(16-1)
      mov di,(16-2)
      add cx,1
      add dx,1
      call rectangle_gradient_right

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],14
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],1
      add [Line.y2],14
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      xor eax,eax
      mov eax,[AveregeColor]
      mov [Pixel.color],eax

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      add ebx,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;----------------
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,15
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,15
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      and [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],9
      add [Line.y2],5
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],10
      add [Line.y2],6
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],8
      add [Line.x2],12
      add [Line.y1],5
      add [Line.y2],9
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],8
      add [Line.x2],12
      add [Line.y1],6
      add [Line.y2],10
      call DrawLine

      ;draw vertical down rectangle
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      sub bx,16
      mov [Rectangle.x],eax
      mov [Rectangle.y],ebx
      mov [Rectangle.width],16
      mov [Rectangle.height],16

      mov eax,[pointer]
      and eax,0xffffff
      mov [Rectangle.color],eax
      call RectangleContour

      ;draw gradient right
      mov eax,[Scroler.color1]
      mov ebx,dword 0xffffff
      and eax,0xffffff
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov cx,[Scroler.x]
      mov dx,[Scroler.y]
      add dx,[Scroler.length]
      sub dx,(16-1)
      mov si,(16-1)
      mov di,(16-2)
      add cx,1
      call rectangle_gradient_right

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      sub ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],1
      add [Line.x2],15
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add bx,[Scroler.length]
      sub ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],14
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      sub ebx,15
      add eax,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],14
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      add eax,1
      sub ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16
      mov [length],eax

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,16
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      add ebx,16
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;----------------
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,1
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,15
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,15
      add ebx,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16
      mov [length],eax

      and [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],7
      add [Line.y2],11
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],6
      add [Line.y2],10
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],7
      add [Line.y2],11
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],6
      add [Line.y2],10
      call DrawLine

      no_redraw_all_vertical_scroler:

      xor eax,eax
      mov al,[Scroler.type]
      and al,100000b
      test al,al
      jz no_move_vertical_scroler_bar_3D

	xor eax,eax
	mov ax,[Scroler.x]
	mov ebx,[ScrollBar.y]
	mov ecx,[ScrolerSize]
	call DrawVertical3DScrollBar

	and [Scroler.type],11011111b
	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_move_vertical_scroler_bar_3D:

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov cx,16
      mov dx,[Scroler.length]
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add ebx,17
      sub edx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_vertical_scroler_3D_

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp exit_crossing_vertical_scroler_3D
      no_crossing_vertical_scroler_3D_:

	;check button of mouse
	mov eax,[ButtonsOfMouse]

	and eax,1b
	test al,al
	jnz mouse_button_pressed_vertical

	  and [Scroler.type],10011111b
	  mov esi,Scroler
	  mov edi,[PointerForScroler]
	  add esi,44
	  add edi,44
	  mov ecx,19
	  rep movsb
	 mouse_button_pressed_vertical:

      exit_crossing_vertical_scroler_3D:


      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_change_vertical_scroler_3D

	xor eax,eax
	xor ebx,ebx
	mov ax,[Scroler.x]
	mov bx,[Scroler.mouseX]

	sub eax,ebx
	jns no_signum_1
	neg eax
	no_signum_1:

	cmp eax,110
	jle no_change_bits_vertical_scroler_3D

	and [Scroler.type],10011111b
	no_change_bits_vertical_scroler_3D:

	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_change_vertical_scroler_3D:

      no_vertical_scroler_3D:

      ;****************Horinzontal scroler**************

      ;is a horizontal 3D scroler ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,10b
      test al,al
      jz no_horizontal_scroler_3D

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov cx,[Scroler.length]
      mov dx,16
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add eax,17
      sub ecx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_horizontal_scroler_3D

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      no_crossing_horizontal_scroler_3D:

      ;is a vertical 3D scroler active ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_horizontal_scroler_active

      ;calculate size of scroll bar
      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16+16
      mov [v],eax
      fld [Scroler.size]
      fild [v]
      fmul st0,st1
      fistp [ScrolerSize]
      fstp [v]

      cmp [ScrolerSize],4
      jae no_minimum_size_horizontal_3D_scroler

	mov [ScrolerSize],4
      no_minimum_size_horizontal_3D_scroler:

      ;if scroler is not active than use this is coordinats.
      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,17+17
      sub eax,[ScrolerSize]
      mov [xo],eax
      fld [Scroler.pos]
      fild [xo]
      fmul st0,st1
      fistp [v]
      fstp [v2]

      xor eax,eax
      mov ax,[Scroler.x]
      add ax,17
      add eax,[v]
      mov [ScrollBar.x],eax

      ;check button of mouse
      mov eax,[ButtonsOfMouse]

      and eax,1b
      test al,al
      jz no_horizontal_scroler_move
      ;calculate in pixels length of scroll bar

      xor eax,eax
      xor edx,edx
      xor ecx,ecx
      mov ax,[Scroler.x]
      mov cx,[Scroler.length]
      mov dx,[Scroler.mouseX]
      mov ebx,edx
      add ecx,eax
      add eax,17
      sub ecx,17
      mov esi,ecx

      sub ebx,eax
      jns no_minimum_scroler_x_

      mov [Scroler.mouseX],ax
      no_minimum_scroler_x_:

      sub ecx,edx
      jns no_maximum_scroler_x_

      mov [Scroler.mouseX],si
      no_maximum_scroler_x_:


      mov eax,[ScrolerSize]
      shr eax,1
      xor ebx,ebx
      mov bx,[Scroler.mouseX]
      sub bx,[Scroler.x]
      sub ebx,17
      xor ecx,ecx
      mov cx,[Scroler.x]
      add cx,[Scroler.length]
      sub cx,17
      sub cx,[Scroler.mouseX]

      cmp ebx,eax
      jae no_correct_x_
       xor edx,edx
       mov dx,[Scroler.x]
       add dx,17
       add edx,eax
      no_correct_x_:

      cmp ecx,eax
      jae no_correct_x__
       xor edx,edx
       mov dx,[Scroler.x]
       add dx,[Scroler.length]
       sub dx,17
       sub edx,eax
      no_correct_x__:

      mov [ScrollBar.x],edx
      sub [ScrollBar.x],eax
      sub dx,[Scroler.x]
      sub edx,17
      sub edx,eax
      mov [v],edx

      xor ebx,ebx
      mov bx,[Scroler.length]
      sub ebx,17+17
      sub ebx,[ScrolerSize]
      mov [v2],ebx

      fild [v2]
      fild [v]
      fdiv st0,st1
      fstp [Scroler.pos]
      fistp [v2]

      ;put 5 bit(scroll bar move)
      or [Scroler.type],100000b

      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp no_horizontal_scroler_active
      no_horizontal_scroler_move:

      no_horizontal_scroler_active:

      ;if bit 7 is a true than redraw all scroler.

      xor eax,eax
      mov al,[Scroler.type]
      and al,10000000b
      test al,al
      jz no_redraw_all_horizontal_scroler

      and [Scroler.type],01111111b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      ;draw vertical up rectangle
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Rectangle.x],eax
      mov [Rectangle.y],ebx
      mov [Rectangle.width],16
      mov [Rectangle.height],16

      mov eax,[pointer]
      and eax,0xffffff
      mov [Rectangle.color],eax
      call RectangleContour

      ;draw gradient right
      mov eax,[Scroler.color1]
      mov ebx,dword 0xffffff
      and eax,0xffffff
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov cx,[Scroler.x]
      mov dx,[Scroler.y]
      mov si,(16-1)
      mov di,(16-2)
      add cx,1
      add dx,1
      call rectangle_gradient_up

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],14
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],1
      add [Line.y2],14
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      xor eax,eax
      mov eax,[AveregeColor]
      mov [Pixel.color],eax

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      add ebx,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;----------------
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,15
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,15
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],5
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],4
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],6
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],5
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],5
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],12
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],6
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],11
      call DrawLine

      ;draw vertical down rectangle
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      sub ax,16
      mov [Rectangle.x],eax
      mov [Rectangle.y],ebx
      mov [Rectangle.width],16
      mov [Rectangle.height],16

      mov eax,[pointer]
      and eax,0xffffff
      mov [Rectangle.color],eax
      call RectangleContour

      ;draw gradient right
      mov eax,[Scroler.color1]
      mov ebx,dword 0xffffff
      and eax,0xffffff
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov cx,[Scroler.x]
      mov dx,[Scroler.y]
      add cx,[Scroler.length]
      sub cx,16
      mov si,(16-1)
      mov di,(16-2)
      add cx,1
      add dx,1
      call rectangle_gradient_up

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      sub eax,15
      add ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,1
      add ax,[Scroler.length]
      sub eax,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],14
      mov ecx,[pointer+10*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      sub eax,15
      add ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      mov ecx,[Color];[pointer]
      mov [Line.color],ecx
      call DrawLine

      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16
      mov [length],eax

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,16
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,16
      add ebx,16
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      ;----------------
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,1
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,1
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,1
      add ebx,15
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      add ebx,15
      add eax,[length]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16
      mov [length],eax

      and [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],4
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],11
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],5
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],12
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],11
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],11
      call DrawLine

      no_redraw_all_horizontal_scroler:

      xor eax,eax
      mov al,[Scroler.type]
      and al,100000b
      test al,al
      jz no_move_horizontal_scroler_bar_3D

	xor ebx,ebx
	mov bx,[Scroler.y]
	mov eax,[ScrollBar.x]
	mov ecx,[ScrolerSize]
	call DrawHorizontal3DScrollBar

	and [Scroler.type],11011111b
	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_move_horizontal_scroler_bar_3D:

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov dx,16
      mov cx,[Scroler.length]
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add eax,17
      sub ecx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_horizontal_scroler_3D_

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp exit_crossing_horizontal_scroler_3D
      no_crossing_horizontal_scroler_3D_:

	;check button of mouse
	mov eax,[ButtonsOfMouse]

	and eax,1b
	test al,al
	jnz mouse_button_pressed_horizontal

	  and [Scroler.type],10011111b
	  mov esi,Scroler
	  mov edi,[PointerForScroler]
	  add esi,44
	  add edi,44
	  mov ecx,19
	  rep movsb
	 mouse_button_pressed_horizontal:

      exit_crossing_horizontal_scroler_3D:


      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_change_horizontal_scroler_3D

	xor eax,eax
	xor ebx,ebx
	mov ax,[Scroler.y]
	mov bx,[Scroler.mouseY]

	sub eax,ebx
	jns no_signum_1_x
	neg eax
	no_signum_1_x:

	cmp eax,110
	jle no_change_bits_horizontal_scroler_3D

	and [Scroler.type],10011111b
	no_change_bits_horizontal_scroler_3D:

	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_change_horizontal_scroler_3D:

      no_horizontal_scroler_3D:

      no_3D_scroler:

      ;****************************************************
      ;********************2D scrolers*********************
      ;****************************************************

      xor eax,eax
      mov al,[Scroler.type]
      and al,10000b
      test al,al
      jnz no_2D_scroler

      mov eax,[Scroler.color1]
      mov ebx,0xffffff
      mov ecx,16
      mov edx,pointer
      call gradient

      mov eax,[pointer+9]
      and eax,0xffffff
      mov [Color],eax

      mov eax,[pointer]
      mov ebx,0xffffff
      call calculate_average_color
      mov [AveregeColor],eax

      ;is a vertical 2D scroler ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,1b
      test al,al
      jz no_vertical_scroler_2D

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov cx,16
      mov dx,[Scroler.length]
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add ebx,17
      sub edx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_vertical_scroler_2D

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      no_crossing_vertical_scroler_2D:

      ;is a vertical 2D scroler active ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_vertical_scroler_active_2D

      ;calculate size of scroll bar
      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16+16
      mov [v],eax
      fld [Scroler.size]
      fild [v]
      fmul st0,st1
      fistp [ScrolerSize]
      fstp [v]

      cmp [ScrolerSize],4
      jae no_minimum_size_vertical_2D_scroler

	mov [ScrolerSize],4
      no_minimum_size_vertical_2D_scroler:

      ;if scroler is not active than use this is coordinats.
       xor eax,eax
      mov ax,[Scroler.length]
      sub eax,17+17
      sub eax,[ScrolerSize]
      mov [yo],eax
      fld [Scroler.pos]
      fild [yo]
      fmul st0,st1
      fistp [v]
      fstp [v2]

      xor eax,eax
      mov ax,[Scroler.y]
      add ax,16
      add eax,[v]
      mov [ScrollBar.y],eax

      ;check button of mouse
      mov eax,[ButtonsOfMouse]

      and eax,1b
      test al,al
      jz no_vertical_scroler_move_2D
      ;calculate in pixels length of scroll bar

      xor eax,eax
      xor edx,edx
      xor ecx,ecx
      mov ax,[Scroler.y]
      mov cx,[Scroler.length]
      mov dx,[Scroler.mouseY]
      mov ebx,edx
      add ecx,eax
      add eax,17
      sub ecx,17
      mov esi,ecx

      sub ebx,eax
      jns no_minimum_scroler_y_2D

      mov [Scroler.mouseY],ax
      no_minimum_scroler_y_2D:

      sub ecx,edx
      jns no_maximum_scroler_y_2D

      mov [Scroler.mouseY],si
      no_maximum_scroler_y_2D:


      mov eax,[ScrolerSize]
      shr eax,1
      xor ebx,ebx
      mov bx,[Scroler.mouseY]
      sub bx,[Scroler.y]
      sub ebx,17
      xor ecx,ecx
      mov cx,[Scroler.y]
      add cx,[Scroler.length]
      sub cx,17
      sub cx,[Scroler.mouseY]

      cmp ebx,eax
      jae no_correct_y_2D_
       xor edx,edx
       mov dx,[Scroler.y]
       add dx,16
       add edx,eax
      no_correct_y_2D_:

      cmp ecx,eax
      jae no_correct_y_2D
       xor edx,edx
       mov dx,[Scroler.y]
       add dx,[Scroler.length]
       sub dx,16
       sub edx,eax
      no_correct_y_2D:

      mov [ScrollBar.y],edx
      sub [ScrollBar.y],eax
      sub dx,[Scroler.y]
      sub edx,16
      sub edx,eax
      mov [v],edx

      shl eax,1
      xor ebx,ebx
      mov bx,[Scroler.length]
      sub ebx,16+16
      sub ebx,[ScrolerSize]
      mov [v2],ebx

      fild [v2]
      fild [v]
      fdiv st0,st1
      fstp [Scroler.pos]
      fistp [v2]

      ;put 5 bit(scroll bar move)
      or [Scroler.type],100000b

      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp no_vertical_scroler_active_2D
      no_vertical_scroler_move_2D:

      no_vertical_scroler_active_2D:

      ;if bit 7 is a true than redraw all scroler.

      xor eax,eax
      mov al,[Scroler.type]
      and al,10000000b
      test al,al
      jz no_redraw_all_vertical_scroler_2D

      and [Scroler.type],01111111b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      ;generate colors tables
      mov eax,[Scroler.color1]
      mov ebx,0xffffff
      mov ecx,20
      mov edx,colors_table1
      call gradient

      xor eax,eax
      mov ebx,[Scroler.color1]
      mov ecx,20
      mov edx,colors_table2
      call gradient

      ;draw vertical up rectangle
      mov eax,13
      mov edx,[Color]
      xor ebx,ebx
      xor ecx,ecx
      mov bx,[Scroler.x]
      mov cx,[Scroler.y]
      shl ebx,16
      shl ecx,16
      add ebx,16
      add ecx,16
      and edx,0xffffff
      int 0x40

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      mov ecx,[colors_table1+15*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],14
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      mov ecx,[colors_table2+8*3];[pointer]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      call DrawLine

      and [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],9
      add [Line.y2],5
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],10
      add [Line.y2],6
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],8
      add [Line.x2],12
      add [Line.y1],5
      add [Line.y2],9
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],8
      add [Line.x2],12
      add [Line.y1],6
      add [Line.y2],10
      call DrawLine

      ;draw vertical down rectangle
      xor ebx,ebx
      xor ecx,ecx
      mov eax,13
      mov edx,[Color]
      and edx,0xffffff
      mov bx,[Scroler.x]
      mov cx,[Scroler.y]
      add cx,[Scroler.length]
      sub cx,16
      shl ebx,16
      shl ecx,16
      add ebx,16
      add ecx,16
      int 0x40

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      sub ebx,16
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      mov ecx,[colors_table1+15*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      sub ebx,16
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      sub ebx,16
      add eax,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      mov ecx,[colors_table2+8*3];[pointer]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add bx,[Scroler.length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      call DrawLine

      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16
      mov [length],eax

      and [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],7
      add [Line.y2],11
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],4
      add [Line.x2],8
      add [Line.y1],6
      add [Line.y2],10
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],7
      add [Line.y2],11
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],6
      add [Line.y2],10
      call DrawLine

      no_redraw_all_vertical_scroler_2D:

      xor eax,eax
      mov al,[Scroler.type]
      and al,100000b
      test al,al
      jz no_move_vertical_scroler_bar_2D

	xor eax,eax
	mov ax,[Scroler.x]
	mov ebx,[ScrollBar.y]
	mov ecx,[ScrolerSize]
	call DrawVertical2DScrollBar

	and [Scroler.type],11011111b
	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_move_vertical_scroler_bar_2D:

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov cx,16
      mov dx,[Scroler.length]
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add ebx,17
      sub edx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_vertical_scroler_2D_

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp exit_crossing_vertical_scroler_2D
      no_crossing_vertical_scroler_2D_:

	;check button of mouse
	mov eax,[ButtonsOfMouse]

	and eax,1b
	test al,al
	jnz mouse_button_pressed_vertical_2D

	  and [Scroler.type],10011111b
	  mov esi,Scroler
	  mov edi,[PointerForScroler]
	  add esi,44
	  add edi,44
	  mov ecx,19
	  rep movsb
	 mouse_button_pressed_vertical_2D:

      exit_crossing_vertical_scroler_2D:


      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_change_vertical_scroler_2D

	xor eax,eax
	xor ebx,ebx
	mov ax,[Scroler.x]
	mov bx,[Scroler.mouseX]

	sub eax,ebx
	jns no_signum_1_y_2D
	neg eax
	no_signum_1_y_2D:

	cmp eax,110
	jle no_change_bits_vertical_scroler_2D

	and [Scroler.type],10011111b
	no_change_bits_vertical_scroler_2D:

	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_change_vertical_scroler_2D:

      no_vertical_scroler_2D:

      ;****************Horinzontal scroler**************

      ;is a horizontal 2D scroler ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,10b
      test al,al
      jz no_horizontal_scroler_2D

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov cx,[Scroler.length]
      mov dx,16
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add eax,17
      sub ecx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_horizontal_scroler_2D

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      no_crossing_horizontal_scroler_2D:

      ;is a vertical 3D scroler active ?
      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_horizontal_scroler_active_2D

      ;calculate size of scroll bar
      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16+16
      mov [v],eax
      fld [Scroler.size]
      fild [v]
      fmul st0,st1
      fistp [ScrolerSize]
      fstp [v]

      cmp [ScrolerSize],4
      jae no_minimum_size_horizontal_2D_scroler

	mov [ScrolerSize],4
      no_minimum_size_horizontal_2D_scroler:

      ;if scroler is not active than use this is coordinats.
       xor eax,eax
      mov ax,[Scroler.length]
      sub eax,17+17
      sub eax,[ScrolerSize]
      mov [yo],eax
      fld [Scroler.pos]
      fild [yo]
      fmul st0,st1
      fistp [v]
      fstp [v2]

      xor eax,eax
      mov ax,[Scroler.x]
      add ax,16
      add eax,[v]
      mov [ScrollBar.x],eax

      ;check button of mouse
      mov eax,[ButtonsOfMouse]

      and eax,1b
      test al,al
      jz no_horizontal_scroler_move_2D
      ;calculate in pixels length of scroll bar

      xor eax,eax
      xor edx,edx
      xor ecx,ecx
      mov ax,[Scroler.x]
      mov cx,[Scroler.length]
      mov dx,[Scroler.mouseX]
      mov ebx,edx
      add ecx,eax
      add eax,17
      sub ecx,17
      mov esi,ecx

      sub ebx,eax
      jns no_minimum_scroler_x_2D

      mov [Scroler.mouseX],ax
      no_minimum_scroler_x_2D:

      sub ecx,edx
      jns no_maximum_scroler_x_2D

      mov [Scroler.mouseX],si
      no_maximum_scroler_x_2D:


      mov eax,[ScrolerSize]
      shr eax,1
      xor ebx,ebx
      mov bx,[Scroler.mouseX]
      sub bx,[Scroler.x]
      sub ebx,17
      xor ecx,ecx
      mov cx,[Scroler.x]
      add cx,[Scroler.length]
      sub cx,17
      sub cx,[Scroler.mouseX]

      cmp ebx,eax
      jae no_correct_x_2D
       xor edx,edx
       mov dx,[Scroler.x]
       add dx,16
       add edx,eax
      no_correct_x_2D:

      cmp ecx,eax
      jae no_correct_x__2D
       xor edx,edx
       mov dx,[Scroler.x]
       add dx,[Scroler.length]
       sub dx,16
       sub edx,eax
      no_correct_x__2D:

      mov [ScrollBar.x],edx
      sub [ScrollBar.x],eax
      sub dx,[Scroler.x]
      sub edx,16
      sub edx,eax
      mov [v],edx

      xor ebx,ebx
      mov bx,[Scroler.length]
      sub ebx,16+16
      sub ebx,[ScrolerSize]
      mov [v2],ebx

      fild [v2]
      fild [v]
      fdiv st0,st1
      fstp [Scroler.pos]
      fistp [v2]

      ;put 5 bit(scroll bar move)
      or [Scroler.type],100000b

      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp no_horizontal_scroler_active_2D
      no_horizontal_scroler_move_2D:

      no_horizontal_scroler_active_2D:

      ;if bit 7 is a true than redraw all scroler.

      xor eax,eax
      mov al,[Scroler.type]
      and al,10000000b
      test al,al
      jz no_redraw_all_horizontal_scroler_2D

      and [Scroler.type],01111111b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      ;generate colors tables
      mov eax,[Scroler.color1]
      mov ebx,0xffffff
      mov ecx,20
      mov edx,colors_table1
      call gradient

      xor eax,eax
      mov ebx,[Scroler.color1]
      mov ecx,20
      mov edx,colors_table2
      call gradient

      ;draw vertical up rectangle
      xor ebx,ebx
      xor ecx,ecx
      mov eax,13
      mov bx,[Scroler.x]
      mov cx,[Scroler.y]
      shl ebx,16
      shl ecx,16
      add ebx,16
      add ecx,16
      mov edx,[Color]
      and edx,0xffffff
      int 0x40

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      mov ecx,[colors_table1+15*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      mov ecx,[colors_table2+8*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],14
      call DrawLine

      and [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],5
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],4
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],6
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],5
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],5
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],12
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],6
      add [Line.x2],9
      add [Line.y1],8
      add [Line.y2],11
      call DrawLine

      ;draw vertical down rectangle
      xor ebx,ebx
      xor ecx,ecx
      mov eax,13
      mov edx,[Color]
      mov bx,[Scroler.x]
      mov cx,[Scroler.y]
      add bx,[Scroler.length]
      sub bx,16
      shl ebx,16
      shl ecx,16
      add ebx,16
      add ecx,16
      and edx,0xffffff
      int 0x40

      ;draw horizontal up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      sub eax,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      mov ecx,[colors_table1+15*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      sub eax,16
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      call DrawLine

      ;draw vertical up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      mov ecx,[colors_table2+8*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add ax,[Scroler.length]
      sub eax,15
      add ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      call DrawLine

      xor eax,eax
      mov ax,[Scroler.length]
      sub eax,16
      mov [length],eax

      and [Line.color],0

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],4
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],11
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],5
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],12
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],12
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      add eax,[length]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],11
      add [Line.x2],8
      add [Line.y1],8
      add [Line.y2],11
      call DrawLine

      no_redraw_all_horizontal_scroler_2D:

      xor eax,eax
      mov al,[Scroler.type]
      and al,100000b
      test al,al
      jz no_move_horizontal_scroler_bar_2D

	xor ebx,ebx
	mov bx,[Scroler.y]
	mov eax,[ScrollBar.x]
	mov ecx,[ScrolerSize]
	call DrawHorizontal2DScrollBar

	and [Scroler.type],11011111b
	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_move_horizontal_scroler_bar_2D:

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor edx,edx
      xor esi,esi
      xor edi,edi
      mov ax,[Scroler.x]
      mov bx,[Scroler.y]
      mov dx,16
      mov cx,[Scroler.length]
      mov si,[Scroler.mouseX]
      mov di,[Scroler.mouseY]
      add eax,17
      sub ecx,17+17
      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crossing_horizontal_scroler_2D_

      or [Scroler.type],1000000b
      mov esi,Scroler
      mov edi,[PointerForScroler]
      add esi,44
      add edi,44
      mov ecx,19
      rep movsb

      jmp exit_crossing_horizontal_scroler_2D
      no_crossing_horizontal_scroler_2D_:

	;check button of mouse
	mov eax,[ButtonsOfMouse]

	and eax,1b
	test al,al
	jnz mouse_button_pressed_horizontal_2D

	  and [Scroler.type],10011111b
	  mov esi,Scroler
	  mov edi,[PointerForScroler]
	  add esi,44
	  add edi,44
	  mov ecx,19
	  rep movsb
	 mouse_button_pressed_horizontal_2D:

      exit_crossing_horizontal_scroler_2D:


      xor eax,eax
      mov al,[Scroler.type]
      and al,1000000b
      test al,al
      jz no_change_horizontal_scroler_2D

	xor eax,eax
	xor ebx,ebx
	mov ax,[Scroler.y]
	mov bx,[Scroler.mouseY]

	sub eax,ebx
	jns no_signum_1_x_2D
	neg eax
	no_signum_1_x_2D:

	cmp eax,110
	jle no_change_bits_horizontal_scroler_2D

	and [Scroler.type],10011111b
	no_change_bits_horizontal_scroler_2D:

	mov esi,Scroler
	mov edi,[PointerForScroler]
	add esi,44
	add edi,44
	mov ecx,19
	rep movsb

      no_change_horizontal_scroler_2D:

      no_horizontal_scroler_2D:

      no_2D_scroler:

      exit_scroler:

      ret 8

;****************************************************
;******************Crate Zakladka********************
;****************************************************
;IN
;pointer to parend
;pointer to Zakladka's structure
;OUT
;pointer to initialized Zakladka's structure
align 4

crate_zakladka:

      pop [ReturnAddresZakladka]
      pop eax
      pop ebx

      mov [PointerToStructureForZakladka],eax
      mov [ParendForZakladka],ebx

      mov ebx,eax

      ;calculate size of memory for control

      ;number of strings
      mov ecx,[ebx+26]
      add ebx,26+4
      xor edx,edx
      ;calculate total number of zakladkas
      next_string_add:

	add edx,[ebx]
	add ebx,4

      dec ecx
      jnz next_string_add
      ;edx=chislo zakladok
      mov [ChisloZakladok],edx

      ;save addres
      mov edi,ebx

      xor esi,esi
      next_zakladka_calculate:

	;total number of controls on zakladka
	mov ecx,[ebx+4]
	shl ecx,3
	add esi,ecx

	add ebx,8
	add ebx,ecx

      dec edx
      jnz next_zakladka_calculate

      mov ecx,ebx
      sub ebx,eax
      mov eax,ebx
      add eax,44+(44*4)

      ;eax= size of memory for control
      push ebx
      push edi

      mov ebx,[ParendForZakladka]
      call crate_control

      pop edi
      pop ebx


      ;set all button's parameters in control
      mov [eax],dword zakladka

      push edi

      mov ecx,ebx
      mov esi,[PointerToStructureForZakladka]
      mov edi,eax
      add edi,44
      rep movsb

      pop edi

      mov [eax+44+22],ebx

      ;crate child controls for parend(zakladka)


      ;set coordinats and size of control
      mov ebx,[PointerToStructureForZakladka]
      mov ecx,[ebx+2]	;button x
      mov edx,[ebx+6]	;button y
      mov esi,[ebx+10]	 ;button size x
      mov edi,[ebx+14]	 ;button size y
      ;copy information to control
      mov [eax+24],ecx
      mov [eax+28],edx
      mov [eax+32],esi
      mov [eax+36],edi

      ;load addres
      mov ebx,eax
      add ebx,44
      mov edx,[ebx+26]
      mov ecx,edx
      mov esi,[ChisloZakladok]
      mov [Zakladka.counter1],esi
      ;sizex*17
      shl ecx,4
      add ecx,edx
      mov [Zakladka.sizey],ecx

      mov ecx,edx
      shl ecx,2

      add ebx,26+4
      add ebx,ecx	;pointer to information for first zakladka

      next_zakladka_crate_childs:

	;total number of controls on zakladka
	 mov ecx,[ebx+4]
	 mov [Zakladka.counter2],ecx
	 add ebx,8

	 test ecx,ecx
	 jz no_controls_for_current_zakladka

	 next_child_for_zakladka:

	   ;is child button ?
	   cmp [ebx],dword 1
	   jnz no_child_button_for_zakladka

	     mov esi,eax      ;parend
	     mov edi,[ebx+4]  ;information for child

	     push eax
	     push ebx

	      push esi
	      push edi

	      call crate_button

	      pop esi

	     pop ebx
	     pop eax

	      ;save addres of new control
	      mov [ebx+4],esi

	      mov edi,[eax+24]
	      add [esi+24],edi
	      mov edi,[eax+28]
	      add edi,[Zakladka.sizey]
	      add [esi+28],edi
	    jmp exit_child_for_zakladka
	   no_child_button_for_zakladka:

	   ;is child scroler ?
	   cmp [ebx],dword 2
	   jnz no_child_scroler_for_zakladka

	     mov esi,eax      ;parend
	     mov edi,[ebx+4]  ;information for child

	     push eax
	     push ebx

	      push esi
	      push edi

	      call crate_scroler

	      pop esi

	     pop ebx
	     pop eax

	     mov [ebx+4],esi

	     mov edi,[eax+24]
	     add [esi+24],edi
	     mov edi,[eax+28]
	     add edi,[Zakladka.sizey]
	     add [esi+28],edi
	    jmp exit_child_for_zakladka
	   no_child_scroler_for_zakladka:


	   ;is child image ?
	   cmp [ebx],dword 4
	   jnz no_child_image_for_zakladka

	     mov esi,eax      ;parend
	     mov edi,[ebx+4]  ;information for child

	     push eax
	     push ebx

	      push esi
	      push edi

	      call crate_image

	      pop esi

	     pop ebx
	     pop eax

	     mov [ebx+4],esi

	     mov edi,[eax+24]
	     add [esi+24],edi
	     mov edi,[eax+28]
	     add edi,[Zakladka.sizey]
	     add [esi+28],edi
	    jmp exit_child_for_zakladka

	   no_child_image_for_zakladka:

	   ;is child text ?
	   cmp [ebx],dword 5
	   jnz no_child_text_for_zakladka

	     mov esi,eax      ;parend
	     mov edi,[ebx+4]  ;information for child

	     push eax
	     push ebx

	      push esi
	      push edi

	      call crate_text

	      pop esi

	     pop ebx
	     pop eax

	     mov [ebx+4],esi

	     mov edi,[eax+24]
	     add [esi+24],edi
	     mov edi,[eax+28]
	     add edi,[Zakladka.sizey]
	     add [esi+28],edi
	    jmp exit_child_for_zakladka

	   no_child_text_for_zakladka:

	   ;is child number ?
	   cmp [ebx],dword 6
	   jnz no_child_number_for_zakladka

	     mov esi,eax      ;parend
	     mov edi,[ebx+4]  ;information for child

	     push eax
	     push ebx

	      push esi
	      push edi

	      call crate_number

	      pop esi

	     pop ebx
	     pop eax

	     mov [ebx+4],esi

	     mov edi,[eax+24]
	     add [esi+24],edi
	     mov edi,[eax+28]
	     add edi,[Zakladka.sizey]
	     add [esi+28],edi
	    jmp exit_child_for_zakladka

	   no_child_number_for_zakladka:

	  exit_child_for_zakladka:

	  add ebx,8

	 dec [Zakladka.counter2]
	 jnz next_child_for_zakladka

	no_controls_for_current_zakladka:

      dec [Zakladka.counter1]
      jnz next_zakladka_crate_childs

      ;return pointer to control of button
      push eax
      push [ReturnAddresZakladka]

      ret

;****************************************************
;******************Draw Zakladka*********************
;****************************************************
;IN
;pointer to control of Zakladka
;message
;OUT
;not returned value
align 4

zakladka:

      ;get message
      mov eax,[esp+8]

      ;get pointer to control of zakladka
      mov esi,[esp+4]
      mov [PointerForZakladka],esi

      push esi
       mov ebx,[esi+44+22]  ;size of data's structure
       mov edi,Zakladka
       mov ecx,(43*4)+2
       add esi,44
       add esi,ebx
       rep movsb
      pop esi

      cmp [eax],dword 1
      jne no_redraw_all_zakladka

      or [esi+44],byte 1000000b
      no_redraw_all_zakladka:

      cmp [eax],dword 2
      jne no_keys_zakladka

      jmp exit_zakladka
      no_keys_zakladka:

      cmp [eax],dword 3
      jne no_pressed_button_zakladka

      jmp exit_zakladka
      no_pressed_button_zakladka:

      cmp [eax],dword 6
      jne no_mouse_zakladka

      mov esi,[eax+4]
      mov edi,[eax+8]
      mov ecx,[eax+12]
      mov [Zakladka.MouseX],esi
      mov [Zakladka.MouseY],edi
      mov [ButtonsOfMouse],ecx

      ;save message for child buttons
      mov esi,eax
      mov edi,Zakladka.MessageForChildButton
      mov ecx,4
      rep movsd

      no_mouse_zakladka:


      cmp [eax],dword -1
      jne no_delete_zakladka

      jmp exit_zakladka
      no_delete_zakladka:


      ;load coordinats and size from control
      mov eax,[PointerForZakladka]
      mov ebx,[eax+24]		 ;x
      mov ecx,[eax+28]		 ;y
      mov edx,[eax+32]		 ;size x
      mov esi,[eax+36]		 ;size y
      mov edi,[eax+44+18]	 ;color1

      ;set current coordinats and sizes in zakladka
      mov [Zakladka.x],ebx
      mov [Zakladka.y],ecx
      mov [Zakladka.sizex],edx
      mov [Zakladka.sizey],esi
      mov [Zakladka.color1],edi

      mov ebx,[PointerForZakladka]
      add ebx,44
      xor eax,eax
      mov al,[ebx]
      and al,10000000b
      test al,al
      jz  no_redraw_zakladka

      and [ebx],byte 01111111b

      ;generate colors tables

      mov eax,[Zakladka.color1]
      mov ebx,0xffffff
      mov ecx,20
      mov edx,colors_table1
      call gradient

      xor eax,eax
      mov ebx,[Zakladka.color1]
      mov ecx,20
      mov edx,colors_table2
      call gradient

      ;get memory for child buttons of zakladka
      mov eax,50*4
      call malloc
      mov [Zakladka.ChildButtonsForZakladka],eax

      mov ebx,[PointerForZakladka]
      add ebx,44
      mov ecx,[ebx+26]
      mov edx,ecx
      add ebx,26+4
      shl edx,2
      mov esi,ebx
      add esi,edx ;esi= pointer to information for first child
      mov [Zakladka.PointerToTextForZakladka],esi

      mov edi,[Zakladka.y]
      mov [Zakladka.ZakladkaY],edi

      mov edi,[Zakladka.sizex]
      sub edi,3
      mov [Zakladka.FullZakladkaSizeX],edi
      mov [Zakladka.ChisloStrokeZakladok],ecx

      and [Zakladka.CounterChildButtons],0

      ;crate child buttons for zakladkas

      next_string_of_zakladkas:

	mov edi,[Zakladka.x]
	add edi,2
	mov [Zakladka.ZakladkaX],edi
	mov [Zakladka.WorkPlace_windowx],edi

	;total number of zakladkas in string

	mov edx,[ebx]
	mov edi,edx
	mov [Zakladka.NumberZakladkasInEndString],edx

	push eax
	mov eax,[Zakladka.ChildButtonsForZakladka]
	add eax,[Zakladka.CounterChildButtons]
	mov [Zakladka.PointerToEndZakladkas],eax
	pop eax

	;calculate size of zakladka
	;size=(full_size/number_zakladok)
	push eax
	push edx

	mov eax,[Zakladka.FullZakladkaSizeX]
	cdq
	idiv edi

	mov [Zakladka.ZakladkaSizeX],eax
	mov [Zakladka.WorkPlace_windowsizex],eax

	imul eax,edi
	mov edx,[Zakladka.FullZakladkaSizeX]
	sub edx,eax
	mov [Zakladka.DefectSizeX],edx

	pop edx
	pop eax

	next_child_button_crate_for_string:

	  cmp edx,1
	  jne no_disactivate_defect_size_x

	  mov esi,[Zakladka.DefectSizeX]
	  add [Zakladka.ZakladkaSizeX],esi
	  no_disactivate_defect_size_x:

	  ;crate control button for zakladka
	  ;load info to structure
	  mov [ChildButton.type],byte 10001001b
	  mov [ChildButton.color1],0xaabbcc

	  mov esi,[Zakladka.ZakladkaX]
	  mov edi,[Zakladka.ZakladkaY]
	  mov [ChildButton.x],si
	  mov [ChildButton.y],di
	  mov esi,[Zakladka.ZakladkaSizeX]
	  mov [ChildButton.width],si
	  mov [ChildButton.height],word 16

	  mov esi,[Zakladka.PointerToTextForZakladka]
	  mov edi,[esi]
	  mov [ChildButton.text],edi

	  ;save child controls for this child button
	  mov edi,[Zakladka.ChildButtonsForZakladka]
	  add edi,[Zakladka.CounterChildButtons]
	  add edi,4
	  mov [edi],esi

	  ;calculate new pointer for text of zakldka
	  ;get total number of controls for current zakladka
	  mov edi,[esi+4]
	  shl edi,3
	  add esi,edi
	  add esi,8
	  mov [Zakladka.PointerToTextForZakladka],esi

	  pushad

	   push [PointerForZakladka]
	   push ChildButton
	   call crate_button

	   ;save control of child button
	   pop esi
	   mov edi,[Zakladka.ChildButtonsForZakladka]
	   add edi,[Zakladka.CounterChildButtons]
	   mov [edi],esi

	   call DrawZakladka

	   ;load obrabotchik for child button
	   mov edi,[Zakladka.ChildButtonsForZakladka]
	   add edi,[Zakladka.CounterChildButtons]
	   mov esi,[edi]

	   mov [Zakladka.MessageForChildButton],dword 1
	   push Zakladka.MessageForChildButton
	   push esi
	   call button

	   add [Zakladka.CounterChildButtons],8
	  popad

	  mov esi,[Zakladka.ZakladkaSizeX]
	  add [Zakladka.ZakladkaX],esi

	dec edx
	jnz  next_child_button_crate_for_string

	add ebx,4
	add [Zakladka.ZakladkaY],17  ;zakladka size y

      dec ecx
      jnz next_string_of_zakladkas

      ;calculate chislo zakladok
      mov eax,[Zakladka.CounterChildButtons]
      shr eax,3
      mov [Zakladka.ChisloZakladok],eax

      ;draw work place for zakladka
      mov ebx,[Zakladka.ChisloStrokeZakladok]  ;chislo strok
      mov ecx,[Zakladka.x]   ;x for zakladka work place
      shl ebx,4
      mov edx,ebx
      add ebx,[Zakladka.y]   ;y for zakladka work place
      add ebx,[Zakladka.ChisloStrokeZakladok]
      mov esi,[Zakladka.sizey]	;size y
      mov edi,[Zakladka.sizex]	;size x
      sub esi,edx	;size x zakladka work place
      sub esi,1

      mov [Zakladka.WorkPlace_x],ecx
      mov [Zakladka.WorkPlace_y],ebx
      mov [Zakladka.WorkPlace_sizex],edi
      mov [Zakladka.WorkPlace_sizey],esi

      call DrawZakladkaWorkPlace

      mov edi,[Zakladka.CounterChildButtons]
      shr edi,3
      dec edi
      mov [Zakladka.NumberActiveControl],edi

      call SendMessageChildControlsOfZakladka

      jmp exit_zakladka
      no_redraw_zakladka:



      ;check crosing arrea of child buttons
      mov eax,[Zakladka.x]
      mov ebx,[Zakladka.y]
      mov ecx,[Zakladka.sizex]
      mov edx,[Zakladka.ChisloStrokeZakladok]
      shl edx,4
      mov esi,[Zakladka.MouseX]
      mov edi,[Zakladka.MouseY]

      call CheckCrossingBox

      cmp eax,0xffffff
      jne no_crosing_child_buttons_zakladka

	mov eax,[PointerForZakladka]
	mov ecx,[eax+44+26]	      ;chislo zakladok in stroke
	add eax,44+26+4

	and [Zakladka.CounterChildButtons],0
	mov [Zakladka.ZakladkaFlag],0

	next_stroke_zakladka_check_crossing:

	   mov edx,[eax]	      ;number zakladok in string
	   mov [Zakladka.NumberZakladkasInActiveString],edx

	   mov esi,[Zakladka.ChildButtonsForZakladka]
	   add esi,[Zakladka.CounterChildButtons]
	   mov [Zakladka.PointerToActiveZakladkas],esi

	   next_zakladka_in_string_check:

	     pushad

	       mov eax,[Zakladka.ChildButtonsForZakladka]
	       add eax,[Zakladka.CounterChildButtons]
	       mov ebx,[eax]
	       mov [Zakladka.ChildControlForZakladka],ebx

	       push Zakladka.MessageForChildButton
	       push ebx
	       call button

	       add [Zakladka.CounterChildButtons],8
	     popad

	       mov esi,[Zakladka.ChildControlForZakladka]
	       xor ebx,ebx
	       mov bl,byte[esi+44+1]
	       and bl,1b
	       cmp bl,1b
	       jne no_crossing_zakladka___

		cmp [ButtonsOfMouse],1
		jne no_crossing_zakladka___

		mov [Zakladka.ZakladkaFlag],byte 1
		jmp exit_check_crossing_with_zakladka

	       no_crossing_zakladka___:

	   dec edx
	   jnz next_zakladka_in_string_check

	   add eax,4

	dec ecx
	jnz next_stroke_zakladka_check_crossing

	exit_check_crossing_with_zakladka:


	cmp [Zakladka.ZakladkaFlag],1
	jne no_crosing_with_zakladkas

	  mov [Zakladka.ZakladkaFlag],byte 0

	  mov eax,[Zakladka.PointerToEndZakladkas]
	  mov ebx,[eax]
	  mov ecx,[ebx+28]	;y for string of end zakladkas

	  mov edx,[Zakladka.PointerToActiveZakladkas]
	  mov esi,[edx]
	  mov edi,[esi+28]	;y for string of active zakladkas

	  cmp ecx,edi
	  je no_change_Y_coordinats_in_zakladkas

	     mov [Zakladka.y_end_stroke],ecx
	     mov [y],edi	;save y coordinate of active zakladka

	     mov eax,[Zakladka.PointerToActiveZakladkas]
	     mov ecx,[Zakladka.NumberZakladkasInActiveString]
	     ;y_active_string=y_end_string
	     next_zakladka_change_y_active:

		mov edx,[Zakladka.y_end_stroke]
		mov ebx,[eax]	;ebx = pointer to zakladka
		mov [ebx+28],edx

		add eax,8

	     dec ecx
	     jnz next_zakladka_change_y_active

	    mov eax,[Zakladka.PointerToEndZakladkas]
	    mov ecx,[Zakladka.NumberZakladkasInEndString]
	    ;y_end_string=y_active_string
	    next_zakladka_change_y_end:

		mov edx,[y]
		mov ebx,[eax]
		mov [ebx+28],edx

		add eax,8

	    dec ecx
	    jnz next_zakladka_change_y_end

	  mov eax,[Zakladka.PointerToActiveZakladkas]
	  mov ebx,[Zakladka.PointerToEndZakladkas]
	  mov ecx,[Zakladka.NumberZakladkasInActiveString]
	  mov edx,[Zakladka.NumberZakladkasInEndString]

	  mov esi,eax
	  mov edi,ecx

	  mov [Zakladka.PointerToActiveZakladkas],ebx
	  mov [Zakladka.NumberZakladkasInActiveString],edx

	  mov [Zakladka.PointerToEndZakladkas],esi
	  mov [Zakladka.NumberZakladkasInEndString],edi

	  no_change_Y_coordinats_in_zakladkas:

	  mov eax,[Zakladka.ChildButtonsForZakladka]
	  mov ecx,[Zakladka.ChisloZakladok]
	  next_zakladka_redraw:

	     mov ebx,[eax]
	     mov edx,[ebx+24] ;x
	     mov esi,[ebx+28] ;y
	     mov edi,[ebx+32] ;size x
	     mov [Zakladka.ZakladkaX],edx
	     mov [Zakladka.ZakladkaY],esi
	     mov [Zakladka.ZakladkaSizeX],edi
	     mov [Zakladka.ControlAddres],ebx

	     pushad

		call DrawZakladka

		mov [Zakladka.MessageForChildButton],dword 1
		push Zakladka.MessageForChildButton
		push [Zakladka.ControlAddres]
		call button

	     popad

	     add eax,8
	  dec ecx
	  jnz next_zakladka_redraw


	  mov eax,[Zakladka.ChildControlForZakladka]
	  mov ebx,[eax+24]    ;x coordinat of zakladka
	  mov ecx,[eax+32]    ;size x of zakladka
	  mov [Zakladka.WorkPlace_windowx],ebx
	  mov [Zakladka.WorkPlace_windowsizex],ecx

	  ;draw work place for zakladka
	  mov ebx,[Zakladka.ChisloStrokeZakladok]  ;chislo strok
	  mov ecx,[Zakladka.x]	 ;x for zakladka work place
	  shl ebx,4
	  mov edx,ebx
	  add ebx,[Zakladka.y]	 ;y for zakladka work place
	  add ebx,[Zakladka.ChisloStrokeZakladok]
	  mov esi,[Zakladka.sizey]  ;size y
	  mov edi,[Zakladka.sizex]  ;size x
	  sub esi,edx	    ;size x zakladka work place
	  sub esi,1

	  mov [Zakladka.WorkPlace_x],ecx
	  mov [Zakladka.WorkPlace_y],ebx
	  mov [Zakladka.WorkPlace_sizex],edi
	  mov [Zakladka.WorkPlace_sizey],esi

	  call DrawZakladkaWorkPlace

	  mov edi,[Zakladka.CounterChildButtons]
	  shr edi,3
	  mov [Zakladka.NumberActiveControl],edi

	  call SendMessageChildControlsOfZakladka

	  ;delay mouse click
	  mov eax,5
	  mov ebx,10
	  int 0x40

	no_crosing_with_zakladkas:

	jmp exit_zakladka
      no_crosing_child_buttons_zakladka:


       ;check for redraw all zakladka
       mov ebx,[PointerForZakladka]
       add ebx,44
       xor eax,eax
       mov al,[ebx]
       and al,1000000b
       test al,al
       jz  no_redraw_all_zakladka__

       and [ebx],byte 10111111b

	  mov eax,[Zakladka.ChildButtonsForZakladka]
	  mov ecx,[Zakladka.ChisloZakladok]
	  next_zakladka_redraw_all:

	     mov ebx,[eax]
	     mov edx,[ebx+24] ;x
	     mov esi,[ebx+28] ;y
	     mov edi,[ebx+32] ;size x
	     mov [Zakladka.ZakladkaX],edx
	     mov [Zakladka.ZakladkaY],esi
	     mov [Zakladka.ZakladkaSizeX],edi
	     mov [Zakladka.ControlAddres],ebx

	     pushad

		call DrawZakladka

		mov [Zakladka.MessageForChildButton],dword 1
		push Zakladka.MessageForChildButton
		push [Zakladka.ControlAddres]
		call button

	     popad

	     add eax,8
	  dec ecx
	  jnz next_zakladka_redraw_all

	  call DrawZakladkaWorkPlace

	  mov edi,[Zakladka.NumberActiveControl]
	  call SendMessageChildControlsOfZakladka

	  jmp exit_zakladka

       no_redraw_all_zakladka__:

       ;send events to controls of active zakladka
       mov edi,[Zakladka.NumberActiveControl]
       call SendMessageChildControlsOfZakladka

       exit_zakladka:

       ;save work data in control
       mov esi,[PointerForZakladka]
       mov ebx,[esi+44+22]  ;size of data's structure
       mov esi,Zakladka
       mov ecx,(43*4)+2
       mov edi,[PointerForZakladka]
       add edi,44
       add edi,ebx
       rep movsb

      ret 8

;edi - number child zakladka
;SendMessageForChildButton    - message

SendMessageChildControlsOfZakladka:

	;edi - number child zakladka

       mov eax,[PointerForZakladka]
       add eax,44+26
       mov ecx,[eax]   ;number zakladkas
       shl ecx,2
       add eax,4
       add eax,ecx     ;pointer to first child zakladka

       dec edi
       jz addres_find_

	 next_child_control_find:

	    mov ebx,[eax+4]   ;number controls
	    shl ebx,3
	    add eax,8
	    add eax,ebx       ;pointer to next control
	 dec edi
	 jnz next_child_control_find

       addres_find_:

       mov ecx,[eax+4]	 ;number child controls for active zakladka
       mov [Zakladka.CounterChildControls],ecx
       add eax,4+4+4	   ;eax=pointer to child controls for zakladka
       mov [Zakladka.AddresOfActiveChildControl],eax

       send_message_to_next_child_control_of_active_zakladka:

	 mov eax,[Zakladka.AddresOfActiveChildControl]

	 ;redraw control ?

	 cmp [Zakladka.MessageForChildButton],1
	 jne no_redraw_child_control_zakladka

	   ;mov [Zakladka.MessageForChildButton],dword -1

	   mov ebx,[eax]
	   mov ecx,[ebx]
	   push Zakladka.MessageForChildButton
	   push ebx
	   call ecx

	   jmp exit_send_message_to_child_control_zakladka
	 no_redraw_child_control_zakladka:

	 ;send message of keys ?

	 cmp [Zakladka.MessageForChildButton],2
	 jne no_keys_child_control_zakladka

	   mov esi,[Zakladka.ActiveChildControl]
	   test esi,esi
	   jz exit_send_message_to_child_control_zakladka

	     mov eax,[Zakladka.ActiveChildControl]
	     mov ebx,[eax]
	     mov ecx,[ebx]
	     push Zakladka.MessageForChildButton
	     push ebx
	     call ecx

	   jmp exit_send_message_to_child_control_zakladka
	 no_keys_child_control_zakladka:

	 ;Check mouse state ?

	 cmp [Zakladka.MessageForChildButton],6
	 jne no_mouse_child_control_zakladka

	   mov ebx,[eax]
	   mov eax,ebx

	  ;send message to all child controls of active zakladka
	   mov esi,[eax+24]	 ;x
	   mov edi,[eax+28]	 ;y
	   mov ecx,[eax+32]	 ;size x
	   mov edx,[eax+36]	 ;size y
	   mov [x],esi
	   mov [y],edi
	   mov eax,[x]
	   mov ebx,[y]
	   mov esi,[Zakladka.MouseX]
	   mov edi,[Zakladka.MouseY]

	   call CheckCrossingBox

	   cmp eax,0xffffff
	   jne no_crossing_123

	      cmp [Zakladka.MessageForChildButton],1
	      jne button_not_pressed_123

		 ;save addres of activated control
		 mov eax,[Zakladka.AddresOfActiveChildControl]
		 mov [Zakladka.ActiveChildControl],eax

	      button_not_pressed_123:
	    no_crossing_123:

	   no_mouse_child_control_zakladka:
	   ;send message to control
	   mov eax,[Zakladka.AddresOfActiveChildControl]
	   mov ebx,[eax]
	   mov ecx,[ebx]
	   push Zakladka.MessageForChildButton
	   push ebx
	   call ecx

	 exit_send_message_to_child_control_zakladka:

	 add [Zakladka.AddresOfActiveChildControl],4+4

       dec [Zakladka.CounterChildControls]
       jnz  send_message_to_next_child_control_of_active_zakladka


       cmp [Zakladka.MessageForChildButton],dword -1
       jne no_delete_zakladka_

	  and [Zakladka.CounterChildButtons],0

	 next_zakladka_delete:

	  mov eax,[Zakladka.ChildButtonsForZakladka]
	  add eax,[Zakladka.CounterChildButtons]

	  ;destroy child button
	  mov ebx,[eax]   ;control child button
	  push [Zakladka.MessageForChildButton]
	  push ebx
	  call button

	  ;destroy child controls for CURRENT zakladka
	  mov edi,[Zakladka.CounterChildButtons]
	  shr edi,3
	  inc edi

	  mov eax,[PointerForZakladka]
	  add eax,44+26
	  mov ecx,[eax]   ;number zakladkas
	  shl ecx,2
	  add eax,4
	  add eax,ecx	  ;pointer to first child zakladka

	  dec edi
	  jz addres_find___

	    next_child_control_find__:

	       mov ebx,[eax+4]	 ;number controls
	       shl ebx,3
	       add eax,8
	       add eax,ebx	 ;pointer to next control
	    dec edi
	    jnz next_child_control_find__

	  addres_find___:

	  mov ecx,[eax+4]   ;number child controls for active zakladka
	  mov [Zakladka.CounterChildControls],ecx
	  add eax,4+4+4       ;eax=pointer to child controls for zakladka
	  mov [Zakladka.AddresOfActiveChildControl],eax

	     next_child_control_of_zakladka_delete:

	       mov eax,[Zakladka.AddresOfActiveChildControl]
	       mov ebx,[eax]
	       mov ecx,[ebx]

	       push Zakladka.MessageForChildButton
	       push ebx
	       call ecx

	       add [Zakladka.AddresOfActiveChildControl],8

	     dec [Zakladka.CounterChildControls]
	     jnz next_child_control_of_zakladka_delete

	  add [Zakladka.CounterChildButtons],8

	 dec [Zakladka.ChisloZakladok]
	 jnz next_zakladka_delete

       no_delete_zakladka_:

      ret


;****************************************************
;*******************Crate Image**********************
;****************************************************
;IN
;pointer to parend
;pointer to Image's structure
;OUT
;pointer to initialized Image's structure
align 4

crate_image:

      pop [ReturnAddresImage]
      pop eax
      pop ebx

      mov [PointerToStructureForImage],eax

      mov eax,44+26
      call crate_control

      ;set all image's parameters in control
      mov [eax],dword image

      mov ecx,26
      mov esi,[PointerToStructureForImage]
      mov edi,eax
      add edi,44
      rep movsb

      mov ebx,[PointerToStructureForImage]
      mov ecx,[ebx+6]	;x
      mov edx,[ebx+10]	;y
      mov esi,[ebx+14]	;size x
      mov edi,[ebx+18]	;size y
      ;copy information to control
      mov [eax+24],ecx
      mov [eax+28],edx
      mov [eax+32],esi
      mov [eax+36],edi

      ;return pointer to control of image
      push eax
      push [ReturnAddresImage]

      ret

;****************************************************
;********************Draw Image**********************
;****************************************************
;IN
;pointer to control of button
;message
;OUT
;not returned value
align 4

image:

      ;get message
      mov eax,[esp+8]

      ;get pointer to control of image
      mov esi,[esp+4]
      mov [PointerForImage],esi
      ;copy control to local control
      add esi,44
      mov edi,Image
      mov ecx,26
      rep movsb


      cmp [eax],dword 1
      jne no_redraw_all_image

      or [Image.type],10000000b
      no_redraw_all_image:

      cmp [eax],dword 2
      jne no_keys_image

      jmp exit_image
      no_keys_image:

      cmp [eax],dword 3
      jne no_pressed_button_image

      jmp exit_image
      no_pressed_button_image:

      cmp [eax],dword 6
      jne no_mouse_image

      jmp exit_image
      no_mouse_image:


      cmp [eax],dword -1
      jne no_delete_image

      jmp exit_image
      no_delete_image:


      ;load coordinats and size from control
      mov eax,[PointerForImage]
      mov ebx,[eax+24]		 ;x
      mov ecx,[eax+28]		 ;y
      mov edx,[eax+32]		 ;size x
      mov esi,[eax+36]		 ;size y
      ;set current coordinats and sizes in zakladka
      mov [Image.x],ebx
      mov [Image.y],ecx
      mov [Image.sizex],edx
      mov [Image.sizey],esi

      xor eax,eax
      mov al,[Image.type]
      and al,10000000b
      test al,al
      jz no_redraw_image_

       and [Image.type],01111111b

       mov esi,Image
       mov edi,[PointerForImage]
       add edi,44
       mov ecx,2
       rep movsb

       mov eax,7
       mov ebx,[Image.pointer]
       mov ecx,[Image.sizex]
       shl ecx,16
       add ecx,[Image.sizey]
       mov edx,[Image.x]
       shl edx,16
       add edx,[Image.y]
       int 0x40

      no_redraw_image_:

      exit_image:

      ret 8

;****************************************************
;********************Crate Text**********************
;****************************************************
;IN
;pointer to parend
;pointer to Text's structure
;OUT
;pointer to initialized Texr's structure
align 4

crate_text:

      pop [ReturnAddresText]
      pop eax
      pop ebx

      mov [PointerToStructureForText],eax

      mov eax,44+22
      call crate_control

      ;set all image's parameters in control
      mov [eax],dword text

      mov ecx,22
      mov esi,[PointerToStructureForText]
      mov edi,eax
      add edi,44
      rep movsb

      mov ebx,[PointerToStructureForText]
      mov ecx,[ebx+6]	;x
      mov edx,[ebx+10]	;y
      mov esi,[ebx+14]	;length x
      imul esi,6
      ;copy information to control
      mov [eax+24],ecx
      mov [eax+28],edx
      mov [eax+32],esi
      mov [eax+36],dword 9

      ;return pointer to control of image
      push eax
      push [ReturnAddresText]

      ret

;****************************************************
;********************Draw Text**********************
;****************************************************
;IN
;pointer to control of text
;message
;OUT
;not returned value
align 4

text:

      ;get message
      mov eax,[esp+8]

      ;get pointer to control of image
      mov esi,[esp+4]
      mov [PointerForText],esi
      ;copy control to local control
      add esi,44
      mov edi,Text
      mov ecx,22
      rep movsb


      cmp [eax],dword 1
      jne no_redraw_all_text

      or [Text.type],10000000b
      no_redraw_all_text:

      cmp [eax],dword 2
      jne no_keys_text

      jmp exit_text
      no_keys_text:

      cmp [eax],dword 3
      jne no_pressed_button_text

      jmp exit_text
      no_pressed_button_text:

      cmp [eax],dword 6
      jne no_mouse_text

      jmp exit_text
      no_mouse_text:


      cmp [eax],dword -1
      jne no_delete_text

      jmp exit_text
      no_delete_text:


      ;load coordinats and size from control
      mov eax,[PointerForText]
      mov ebx,[eax+24]		 ;x
      mov ecx,[eax+28]		 ;y
      ;set current coordinats and sizes in zakladka
      mov [Text.x],ebx
      mov [Text.y],ecx

      xor eax,eax
      mov al,[Text.type]
      and al,10000000b
      test al,al
      jz no_redraw_text_

       and [Text.type],01111111b

       mov esi,Text
       mov edi,[PointerForText]
       add edi,44
       mov ecx,2
       rep movsb

       mov eax,4
       mov ebx,[Text.x]
       shl ebx,16
       add ebx,[Text.y]
       mov ecx,[Text.color]
       mov edx,[Text.pointer]
       mov esi,[Text.length]
       int 0x40

      no_redraw_text_:

      exit_text:

      ret 8

;****************************************************
;********************Crate Number**********************
;****************************************************
;IN
;pointer to parend
;pointer to Number's structure
;OUT
;pointer to initialized Number's structure
align 4

crate_number:

      pop [ReturnAddresNumber]
      pop eax
      pop ebx

      mov [PointerToStructureForNumber],eax

      mov eax,44+22
      call crate_control

      ;set all image's parameters in control
      mov [eax],dword number

      mov ecx,22
      mov esi,[PointerToStructureForNumber]
      mov edi,eax
      add edi,44
      rep movsb

      mov ebx,[PointerToStructureForNumber]
      mov ecx,[ebx+6]	;x
      mov edx,[ebx+10]	;y
      ;copy information to control
      mov [eax+24],ecx
      mov [eax+28],edx

      ;return pointer to control of image
      push eax
      push [ReturnAddresNumber]

      ret

;****************************************************
;********************Draw Number*********************
;****************************************************
;IN
;pointer to control of number
;message
;OUT
;not returned value
align 4

number:

      ;get message
      mov eax,[esp+8]

      ;get pointer to control of image
      mov esi,[esp+4]
      mov [PointerForNumber],esi
      ;copy control to local control
      add esi,44
      mov edi,Number
      mov ecx,22
      rep movsb


      cmp [eax],dword 1
      jne no_redraw_all_number

      or [Number.type],10000000b
      no_redraw_all_number:

      cmp [eax],dword 2
      jne no_keys_number

      jmp exit_number
      no_keys_number:

      cmp [eax],dword 3
      jne no_pressed_button_number

      jmp exit_number
      no_pressed_button_number:

      cmp [eax],dword 6
      jne no_mouse_number

      jmp exit_number
      no_mouse_number:


      cmp [eax],dword -1
      jne no_delete_number

      jmp exit_number
      no_delete_number:


      ;load coordinats and size from control
      mov eax,[PointerForNumber]
      mov ebx,[eax+24]		 ;x
      mov ecx,[eax+28]		 ;y
      ;set current coordinats and sizes in zakladka
      mov [Number.x],ebx
      mov [Number.y],ecx

      xor eax,eax
      mov al,[Number.type]
      and al,10000000b
      test al,al
      jz no_redraw_number_

       and [Number.type],01111111b

       mov esi,Number
       mov edi,[PointerForNumber]
       add edi,44
       mov ecx,2
       rep movsb

       mov eax,47
       mov ebx,[Number.parameters]
       mov ecx,[Number.number]
       mov edx,[Number.x]
       shl edx,16
       add edx,[Number.y]
       mov esi,[Number.color]
       int 0x40

      no_redraw_number_:

      exit_number:

      ret 8

;ZakladkaX
;ZakladkaY
;ZakladkaSizeX
;ZakladkaSizeY
DrawZakladka:

      mov eax,[Zakladka.ZakladkaX]
      mov ebx,[Zakladka.ZakladkaY]
      mov [x],eax
      mov [y],ebx

      ;draw rectangle(x+1,y+1,sizex-2,sizey-2)
      mov edx,[colors_table1]
      mov esi,[Zakladka.ZakladkaSizeX]
      sub esi,2

      mov eax,13
      mov ebx,[x]
      mov ecx,[y]
      add ebx,1
      add ecx,1
      shl ebx,16
      shl ecx,16
      add ebx,esi
      add ecx,(16)
      and edx,0xffffff
      int 0x40

      mov eax,[colors_table1+15*3]
      and eax,0xffffff
      mov [Line.color],eax
      mov [Pixel.color],eax
      ;draw white line(x+2,y,x+sizex-3,y)

      mov eax,[x]
      mov ebx,[y]
      mov ecx,eax
      add eax,2
      add ecx,[Zakladka.ZakladkaSizeX]
      sub ecx,3
      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      call DrawLine

      ;draw white line(x,y+2,x,y+sizey)
      mov eax,[x]
      mov ebx,[y]
      mov ecx,ebx
      add ebx,2
      add ecx,(16)
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ecx
      call DrawLine

      mov eax,[x]
      mov ebx,[y]
      add eax,1
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[colors_table1+6*3]
      and eax,0xffffff
      mov [Line.color],eax
      ;draw light line(x+2,y+1,x+sizex-2,y+1)

      mov eax,[x]
      mov ebx,[y]
      mov ecx,eax
      add eax,2
      add ebx,1
      add ecx,[Zakladka.ZakladkaSizeX]
      sub ecx,2
      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      call DrawLine

      ;draw light line(x+1,y+2,x+1,y+sizey-1)
      mov eax,[x]
      mov ebx,[y]
      mov ecx,ebx
      add eax,1
      add ebx,2
      add ecx,(16)
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ecx
      call DrawLine

      mov eax,[colors_table2+9*3]
      and eax,0xffffff
      mov [Line.color],eax
      mov [Pixel.color],eax

      ;draw dark line(x+sizex-1,y+2,x+sizex-1,y+sizey)
      mov eax,[x]
      mov ebx,[y]
      add eax,[Zakladka.ZakladkaSizeX]
      mov edx,ebx
      add ebx,2
      add edx,(16)
      sub eax,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],edx
      call DrawLine

      mov eax,[x]
      mov ebx,[y]
      add eax,[Zakladka.ZakladkaSizeX]
      add ebx,1
      sub eax,2
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[colors_table2+16*3]
      and eax,0xffffff
      mov [Line.color],eax

      ;draw light dark line(x+sizex-2,y+2,x+sizex-2,y+sizey)
      mov eax,[x]
      mov ebx,[y]
      add eax,[Zakladka.ZakladkaSizeX]
      sub eax,2
      mov edx,ebx
      add ebx,2
      add edx,(16)
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],edx
      call DrawLine


      ret

DrawZakladkaWorkPlace:

      mov esi,[Zakladka.WorkPlace_sizex]
      sub esi,1

      mov eax,13
      mov ebx,[Zakladka.WorkPlace_x]
      mov ecx,[Zakladka.WorkPlace_y]
      add ebx,1
      shl ebx,16
      shl ecx,16
      add ebx,esi
      add ecx,[Zakladka.WorkPlace_sizey]
      mov edx,[colors_table1]
      and edx,0xffffff
      int 0x40

      mov eax,[colors_table1+15*3]
      and eax,0xffffff
      mov [Line.color],eax

      ;draw vertical light line(x,y,x,y+sizey)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,ebx
      add ecx,[Zakladka.WorkPlace_sizey]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ecx
      call DrawLine

      ;draw first horizontal light line
      ;(x,y,x+windowx,y)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,[Zakladka.WorkPlace_windowx]

      cmp eax,ecx
      je no_draw_line_00

      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      call DrawLine

      no_draw_line_00:

      ;draw second horizontal light line
      ;(x,y,x+windowx,y)
      mov eax,[Zakladka.WorkPlace_windowx]
      add eax,[Zakladka.WorkPlace_windowsizex]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,[Zakladka.WorkPlace_x]
      add ecx,[Zakladka.WorkPlace_sizex]
      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      call DrawLine

      ;draw next light lines

      mov eax,[colors_table1+4*3]
      and eax,0xffffff
      mov [Line.color],eax

      ;draw vertical light line(x+1,y+1,x+1,y+sizey-1)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,ebx
      add ecx,[Zakladka.WorkPlace_sizey]
      add eax,1
      add ebx,1
      sub ecx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ecx
      call DrawLine

      ;draw first horizontal light line
      ;(x+1,y+1,x+windowx,y+1)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,[Zakladka.WorkPlace_windowx]
      add ebx,1

      cmp eax,ecx
      je no_draw_line_01

      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      ;call DrawLine

      no_draw_line_01:

      ;draw second horizontal light line
      ;(x+1,y+1,x+windowx-2,y+1)
      mov eax,[Zakladka.WorkPlace_windowx]
      mov ecx,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      add eax,[Zakladka.WorkPlace_windowsizex]
      add ecx,[Zakladka.WorkPlace_sizex]
      add eax,1
      add ebx,1
      sub ecx,2
      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      call DrawLine


      mov eax,[colors_table2+9*3]
      and eax,0xffffff
      mov [Line.color],eax

      ;draw vertical dark line(x+sizex,y,x+sizex,y+sizey)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,ebx
      add eax,[Zakladka.WorkPlace_sizex]
      add ecx,[Zakladka.WorkPlace_sizey]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ecx
      call DrawLine

      ;draw horizontal dark line(x+1,y+sizey,x+sizex,y+sizey)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,eax
      add ecx,[Zakladka.WorkPlace_sizex]
      add ebx,[Zakladka.WorkPlace_sizey]
      add eax,1
      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      call DrawLine

      mov eax,[colors_table2+16*3]
      and eax,0xffffff
      mov [Line.color],eax

      ;draw vertical dark line(x+sizex-1,y+1,x+sizex-1,y+sizey-1)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,ebx
      add eax,[Zakladka.WorkPlace_sizex]
      add ecx,[Zakladka.WorkPlace_sizey]
      sub eax,1
      sub ecx,1
      ;add ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ecx
      call DrawLine

      ;draw horizontal dark line(x+1,y+sizey-1,x+sizex-1,y+sizey-1)
      mov eax,[Zakladka.WorkPlace_x]
      mov ebx,[Zakladka.WorkPlace_y]
      mov ecx,eax
      add ecx,[Zakladka.WorkPlace_sizex]
      add ebx,[Zakladka.WorkPlace_sizey]
      add eax,1
      sub ecx,1
      sub ebx,1
      mov [Line.x1],eax
      mov [Line.x2],ecx
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      call DrawLine

      ret

;eax - x
;ebx - y
;ecx - size y in pixels
DrawVertical3DScrollBar:

      mov [x],eax
      mov [y],ebx
      mov [length2],ecx

      mov eax,[x]
      mov ebx,[y]
      mov ecx,[length2]
      mov edx,[pointer]
      and edx,0xffffff
      mov [Rectangle.x],eax
      mov [Rectangle.y],ebx
      mov [Rectangle.width],16
      mov [Rectangle.height],ecx
      mov [Rectangle.color],edx
      call RectangleContour

      ;draw gradient right
      mov eax,[Scroler.color1]
      mov ebx,dword 0xffffff
      and eax,0xffffff
      xor esi,esi
      xor edi,edi
      mov ecx,[x]
      mov edx,[y]
      add edx,1
      mov si,(16-1)
      mov edi,[length2]
      sub edi,2
      call rectangle_gradient_right

      ;------------------
      xor eax,eax
      mov eax,[AveregeColor]
      mov [Pixel.color],eax

      mov eax,[x]
      mov ebx,[y]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add ebx,[length2]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,16
      add ebx,[length2]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,1
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,15
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,1
      add ebx,[length2]
      sub ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,16
      add ebx,[length2]
      sub eax,1
      sub ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      cmp [length2],12
      jl no_draw_reliev_vertical_3D

       mov ebx,[x]
       mov eax,[length2]
       shr eax,1
       add eax,[y]
       add ebx,5
       sub eax,3

       mov [Line.x1],ebx
       mov [Line.x2],ebx
       mov [Line.y1],eax
       mov [Line.y2],eax
       mov [Line.color],0xffffff
       add [Line.x2],6

       mov esi,4
       next_light_line_draw_r_vertical_3D:

	 call DrawLine
	 add [Line.y1],2
	 add [Line.y2],2

       dec esi
       jnz  next_light_line_draw_r_vertical_3D

       mov ebx,[x]
       mov eax,[length2]
       shr eax,1
       add eax,[y]
       add ebx,6
       sub eax,2

       mov ecx,[Scroler.color1]
       mov [Line.x1],ebx
       mov [Line.x2],ebx
       mov [Line.y1],eax
       mov [Line.y2],eax
       mov [Line.color],ecx
       add [Line.x2],6

       mov esi,4
       next_dark_line_draw_r_vertical_3D:

	 call DrawLine
	 add [Line.y1],2
	 add [Line.y2],2

       dec esi
       jnz  next_dark_line_draw_r_vertical_3D

      no_draw_reliev_vertical_3D:


      xor eax,eax
      mov ax,[Scroler.y]
      mov ebx,[y]
      add eax,17

      sub ebx,eax
      jz no_draw_up_rectangle_vertical_3D
      js no_draw_up_rectangle_vertical_3D

      sub ebx,1

      mov edi,ebx

      mov eax,0xe4e4e4
      mov ebx,0xffffff
      xor edx,edx
      mov ecx,[x]
      mov dx,[Scroler.y]
      add edx,17
      sub ecx,1
      mov esi,17
      call rectangle_gradient_right
      no_draw_up_rectangle_vertical_3D:

      xor eax,eax
      mov ax,[Scroler.y]
      add ax,[Scroler.length]
      mov ebx,[y]
      add ebx,[length2]
      sub eax,17

      sub eax,ebx
      jz no_draw_down_rectangle_vertical_3D
      js no_draw_down_rectangle_vertical_3D

      sub eax,1
      mov edi,eax

      mov eax,0xe4e4e4
      mov ebx,0xffffff
      mov ecx,[x]
      xor edx,edx
      mov edx,[y]
      add edx,[length2]
      add edx,1
      sub ecx,1
      mov esi,17
      call rectangle_gradient_right

      no_draw_down_rectangle_vertical_3D:

      ret

;eax - x
;ebx - y
;ecx - size y in pixels
DrawHorizontal3DScrollBar:

      mov [x],eax
      mov [y],ebx
      mov [length2],ecx

      mov eax,[x]
      mov ebx,[y]
      mov ecx,[length2]
      mov edx,[pointer]
      and edx,0xffffff
      mov [Rectangle.x],eax
      mov [Rectangle.y],ebx
      mov [Rectangle.width],ecx
      mov [Rectangle.height],16
      mov [Rectangle.color],edx
      call RectangleContour

      ;draw gradient right
      mov eax,[Scroler.color1]
      mov ebx,dword 0xffffff
      and eax,0xffffff
      xor esi,esi
      xor edi,edi
      mov ecx,[x]
      mov edx,[y]
      add ecx,1
      mov edi,(16-1)
      mov esi,[length2]
      sub esi,2
      call rectangle_gradient_up

      ;------------------
      xor eax,eax
      mov eax,[AveregeColor]
      mov [Pixel.color],eax

      mov eax,[x]
      mov ebx,[y]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add ebx,16
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,[length2]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add ebx,16
      add eax,[length2]
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add eax,1
      add ebx,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add ebx,15
      add eax,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add ebx,1
      add eax,[length2]
      sub eax,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      mov eax,[x]
      mov ebx,[y]
      add ebx,15
      add eax,[length2]
      sub eax,1
      mov [Pixel.x],eax
      mov [Pixel.y],ebx
      call DrawPixel

      cmp [length2],12
      jl no_draw_reliev_horizontal_3D

       mov ebx,[y]
       mov eax,[length2]
       shr eax,1
       add eax,[x]
       add ebx,5
       sub eax,3

       mov [Line.x1],eax
       mov [Line.x2],eax
       mov [Line.y1],ebx
       mov [Line.y2],ebx
       mov [Line.color],0xffffff
       add [Line.y2],6

       mov esi,4
       next_light_line_draw_r_horizontal_3D:

	 call DrawLine
	 add [Line.x1],2
	 add [Line.x2],2

       dec esi
       jnz  next_light_line_draw_r_horizontal_3D

       mov ebx,[y]
       mov eax,[length2]
       shr eax,1
       add eax,[x]
       add ebx,6
       sub eax,2

       mov ecx,[Scroler.color1]
       mov [Line.x1],eax
       mov [Line.x2],eax
       mov [Line.y1],ebx
       mov [Line.y2],ebx
       mov [Line.color],ecx
       add [Line.y2],6

       mov esi,4
       next_dark_line_draw_r_horizontal_3D:

	 call DrawLine
	 add [Line.x1],2
	 add [Line.x2],2

       dec esi
       jnz  next_dark_line_draw_r_horizontal_3D

      no_draw_reliev_horizontal_3D:


      xor eax,eax
      mov ax,[Scroler.x]
      mov ebx,[x]
      add eax,17

      sub ebx,eax
      jz no_draw_up_rectangle_horizontal_3D
      js no_draw_up_rectangle_horizontal_3D

      sub ebx,1

      mov esi,ebx

      mov eax,0xe4e4e4
      mov ebx,0xffffff
      xor ecx,ecx
      mov edx,[y]
      mov cx,[Scroler.x]
      add ecx,17
      sub edx,1
      mov edi,17
      call rectangle_gradient_up
      no_draw_up_rectangle_horizontal_3D:

      xor eax,eax
      mov ax,[Scroler.x]
      add ax,[Scroler.length]
      mov ebx,[x]
      add ebx,[length2]
      sub eax,17

      sub eax,ebx
      jz no_draw_down_rectangle_horizontal_3D
      js no_draw_down_rectangle_horizontal_3D

      sub eax,1
      mov esi,eax

      mov eax,0xe4e4e4
      mov ebx,0xffffff
      mov edx,[y]
      xor ecx,ecx
      mov ecx,[x]
      add ecx,[length2]
      add ecx,1
      sub edx,1
      mov edi,17
      call rectangle_gradient_up

      no_draw_down_rectangle_horizontal_3D:

      ret

;eax - x
;ebx - y
;ecx - size y in pixels
DrawVertical2DScrollBar:

      mov [x],eax
      mov [y],ebx
      mov [length2],ecx

      mov eax,13
      mov edx,[Color]
      mov ebx,[x]
      mov ecx,[y]
      shl ebx,16
      shl ecx,16
      add ebx,16
      add ecx,[length2]
      and edx,0xffffff
      int 0x40

     ;draw horizontal up light line
      mov eax,[x]
      mov ebx,[y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      mov ecx,[colors_table1+15*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      mov eax,[x]
      mov ebx,[y]
      mov ecx,[length2]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      add [Line.y2],ecx
      call DrawLine

      ;draw vertical up dark line
      mov eax,[x]
      mov ebx,[y]
      add eax,15
      mov ecx,[length2]
      sub ecx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],ecx
      mov ecx,[colors_table2+8*3];[pointer]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      mov eax,[x]
      mov ebx,[y]
      mov ecx,[length2]
      add ebx,ecx
      sub ebx,1
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],15
      call DrawLine


      xor eax,eax
      mov ax,[Scroler.y]
      mov ebx,[y]
      add eax,16

      sub ebx,eax
      jz no_draw_up_rectangle_vertical_2D
      js no_draw_up_rectangle_vertical_2D

      mov edi,ebx

      xor ecx,ecx
      mov eax,13
      mov edx,0xe4e4e4
      mov ebx,[x]
      mov cx,[Scroler.y]
      add ecx,16
      shl ebx,16
      shl ecx,16
      add ebx,16
      add ecx,edi
      int 0x40

      no_draw_up_rectangle_vertical_2D:

      xor eax,eax
      mov ax,[Scroler.y]
      add ax,[Scroler.length]
      mov ebx,[y]
      add ebx,[length2]
      sub eax,16

      sub eax,ebx
      jz no_draw_down_rectangle_vertical_2D
      js no_draw_down_rectangle_vertical_2D

      ;sub eax,1
      mov edi,eax

      xor ecx,ecx
      mov eax,13
      mov edx,0xe4e4e4
      mov ebx,[x]
      mov ecx,[y]
      add ecx,[length2]
      shl ebx,16
      shl ecx,16
      add ebx,16
      add ecx,edi
      int 0x40

      no_draw_down_rectangle_vertical_2D:

      ret

;eax - x
;ebx - y
;ecx - size x in pixels
DrawHorizontal2DScrollBar:

      mov [x],eax
      mov [y],ebx
      mov [length2],ecx

      mov eax,13
      mov edx,[Color]
      mov ebx,[x]
      mov ecx,[y]
      shl ebx,16
      shl ecx,16
      add ebx,[length2]
      add ecx,16
      and edx,0xffffff
      int 0x40

     ;draw horizontal up light line
      mov eax,[x]
      mov ebx,[y]
      mov ecx,[length2]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      sub ecx,1
      add [Line.x2],ecx
      mov ecx,[colors_table1+15*3]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw vertical up light line
      mov eax,[x]
      mov ebx,[y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      call DrawLine

      ;draw vertical up dark line
      mov eax,[x]
      mov ebx,[y]
      mov ecx,[length2]
      sub ecx,1
      add eax,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],15
      mov ecx,[colors_table2+8*3];[pointer]
      and ecx,0xffffff
      mov [Line.color],ecx
      call DrawLine

      ;draw horizontal up dark line
      mov eax,[x]
      mov ebx,[y]
      mov ecx,[length2]
      sub ecx,1
      add ebx,15
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],ecx
      call DrawLine


      xor eax,eax
      mov ax,[Scroler.x]
      mov ebx,[x]
      add eax,16

      sub ebx,eax
      jz no_draw_up_rectangle_horizontal_2D
      js no_draw_up_rectangle_horizontal_2D

      mov edi,ebx

      xor ecx,ecx
      xor ebx,ebx
      mov eax,13
      mov edx,0xe4e4e4
      mov bx,[Scroler.x]
      mov cx,[Scroler.y]
      add ebx,16
      shl ebx,16
      shl ecx,16
      add ecx,16
      add ebx,edi
      int 0x40

      no_draw_up_rectangle_horizontal_2D:

      xor eax,eax
      mov ax,[Scroler.x]
      add ax,[Scroler.length]
      mov ebx,[x]
      add ebx,[length2]
      sub eax,16

      sub eax,ebx
      jz no_draw_down_rectangle_horizontal_2D
      js no_draw_down_rectangle_horizontal_2D

      ;sub eax,1
      mov edi,eax

      xor ecx,ecx
      mov eax,13
      mov edx,0xe4e4e4
      mov ebx,[x]
      mov ecx,[y]
      add ebx,[length2]
      shl ebx,16
      shl ecx,16
      add ebx,edi
      add ecx,16
      int 0x40

      no_draw_down_rectangle_horizontal_2D:

      ret

DrawStringOnTheButton:

      ;xor ebx,ebx
      ;mov ebx,[Button.text]
      call GetLengthString
      imul eax,6  ;[Font.sizeX]
      xor ebx,ebx
      mov bx,[Button.width]
      shr eax,1
      shr ebx,1
      sub ebx,eax
      xor eax,eax
      mov ax,[Button.x]
      add eax,ebx
      mov [Font.x],eax
      xor ebx,ebx
      mov bx,[Button.height]
      shr ebx,1
      sub ebx,3;[Font.sizeY]
      xor eax,eax
      mov ax,[Button.y]
      add eax,ebx
      mov [Font.y],eax
      call DrawString

      ret

DrawPictureOnTheButton:

	xor esi,esi
	xor edi,edi
	xor eax,eax
	xor ebx,ebx
	mov ax,[Button.height]
	mov bx,[Button.width]
	mov di,[Button.imageSizeY]
	mov si,[Button.imageSizeX]
	shr ax,1
	shr bx,1
	shr si,1
	shr di,1
	sub ax,di
	sub bx,si
	add ax,[Button.y]
	add bx,[Button.x]
	mov [xo],ebx
	mov [x],ebx
	mov [y],eax

	xor esi,esi
	xor edi,edi
	mov si,[Button.imageSizeX]
	mov di,[Button.imageSizeY]
	mov ebp,[Button.image]

	xor eax,eax
	inc eax

	loop_y_image:

	   mov ebx,[xo]
	   mov [x],ebx

	  xor esi,esi
	  mov si,[Button.imageSizeX]

	  loop_x_image:

	     mov edx,[ebp]
	     and edx,0xffffff
	     cmp edx,[Button.transparentColor]
	     je no_draw_pixel

	       mov ebx,[x]
	       mov ecx,[y]
	       int 0x40
	     no_draw_pixel:

	     add ebp,3
	     add [x],1
	  dec esi
	  jnz  loop_x_image

	  add [y],1
	dec edi
	jnz loop_y_image

      ret

;eax -first color
;ebx- second color
;ecx- x coordinat of rectangle
;edx- y coordinat of rectangle
;esi- rectangle size x
;edi- rectangle size y

rectangle_gradient_right:

      mov [line_coordinat_x],ecx
      mov [line_coordinat_y],edx
      mov [line_size_x],esi
      mov [line_size_y],edi

      mov ecx,esi
      mov edx,pointer
      call gradient

      mov ecx,[line_coordinat_y]
      shl ecx,16
      add ecx,[line_coordinat_y]
      add ecx,[line_size_y]

      mov eax,[line_size_x]
      add [line_coordinat_x],eax

      mov esi,pointer
      mov edi,[line_size_x]

      next_vertical_line_draw_right:

	mov eax,38
	mov ebx,[line_coordinat_x]
	shl ebx,16
	add ebx,[line_coordinat_x]
	mov edx,[esi]
	and edx,0xffffff
	int 0x40

	add esi,3
	sub [line_coordinat_x],1

      dec edi
      jnz  next_vertical_line_draw_right

      ret

;eax -first color
;ebx- second color
;ecx- x coordinat of rectangle
;edx- y coordinat of rectangle
;esi- rectangle size x
;edi- rectangle size y

rectangle_gradient_left:

      mov [line_coordinat_x],ecx
      mov [line_coordinat_y],edx
      mov [line_size_x],esi
      mov [line_size_y],edi

      mov ecx,esi
      mov edx,pointer
      call gradient

      mov ecx,[line_coordinat_y]
      shl ecx,16
      add ecx,[line_coordinat_y]
      add ecx,[line_size_y]

      mov esi,pointer
      mov edi,[line_size_x]

      next_vertical_line_draw_left:

	mov eax,38
	mov ebx,[line_coordinat_x]
	shl ebx,16
	add ebx,[line_coordinat_x]
	mov edx,[esi]
	and edx,0xffffff
	int 0x40

	add esi,3
	add [line_coordinat_x],1

      dec edi
      jnz  next_vertical_line_draw_left

      ret

;eax -first color
;ebx- second color
;ecx- x coordinat of rectangle
;edx- y coordinat of rectangle
;esi- rectangle size x
;edi- rectangle size y

rectangle_gradient_up:

      mov [line_coordinat_x],ecx
      mov [line_coordinat_y],edx
      mov [line_size_x],esi
      mov [line_size_y],edi

      mov ecx,edi
      mov edx,pointer
      call gradient

      mov ebx,[line_coordinat_x]
      shl ebx,16
      add ebx,[line_coordinat_x]
      add ebx,[line_size_x]

      mov eax,[line_size_y]
      add [line_coordinat_y],eax

      mov esi,pointer
      mov edi,[line_size_y]

      next_horizontal_line_draw_up:

	mov eax,38
	mov ecx,[line_coordinat_y]
	shl ecx,16
	add ecx,[line_coordinat_y]
	mov edx,[esi]
	and edx,0xffffff
	int 0x40

	add esi,3
	sub [line_coordinat_y],1

      dec edi
      jnz  next_horizontal_line_draw_up

      ret

;eax -first color
;ebx- second color
;ecx- x coordinat of rectangle
;edx- y coordinat of rectangle
;esi- rectangle size x
;edi- rectangle size y

rectangle_gradient_down:

      mov [line_coordinat_x],ecx
      mov [line_coordinat_y],edx
      mov [line_size_x],esi
      mov [line_size_y],edi

      mov ecx,edi
      mov edx,pointer
      call gradient

      mov ebx,[line_coordinat_x]
      shl ebx,16
      add ebx,[line_coordinat_x]
      add ebx,[line_size_x]

      mov esi,pointer
      mov edi,[line_size_y]

      next_horizontal_line_draw_down:

	mov eax,38
	mov ecx,[line_coordinat_y]
	shl ecx,16
	add ecx,[line_coordinat_y]
	mov edx,[esi]
	and edx,0xffffff
	int 0x40

	add esi,3
	add [line_coordinat_y],1

      dec edi
      jnz  next_horizontal_line_draw_down

      ret

Draw3DActiveButton:

      ;call calculate_average_color
      mov [Line.color],0xffffff;eax

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],3
      sub ecx,1
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],3
      sub ecx,1
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],1
      xor ecx,ecx
      mov cx,[Button.width]
      sub ecx,1
      add [Line.x2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],1
      xor ecx,ecx
      mov cx,[Button.width]
      sub ecx,1
      add [Line.x2],ecx
      call DrawLine

      ret

Put3DActiveButton:

      mov eax,[Button.color1]
      mov [Line.color],eax

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],3
      sub ecx,1
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],3
      sub ecx,1
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],1
      xor ecx,ecx
      mov cx,[Button.width]
      sub ecx,1
      add [Line.x2],ecx
      call DrawLine

      xor eax,eax
      mov eax,[pointer+3*3]
      and eax,0xffffff
      mov ebx,0xffffff
      call calculate_average_color
      mov [Line.color],eax

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],1
      xor ecx,ecx
      mov cx,[Button.width]
      sub ecx,1
      add [Line.x2],ecx
      call DrawLine

      ret

DrawPressed3DButton:


      mov eax,[Button.color1]
      mov ebx,0xffffff
      mov ecx,20
      mov edx,pointer
      call gradient

      mov edx,[pointer+3]
      and edx,0xffffff
      mov [Line.color],edx

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],3
      sub ecx,1
      add [Line.y2],ecx
      call DrawLine

      mov edx,[pointer+36]
      and edx,0xffffff
      mov [Line.color],edx

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y1],3
      sub ecx,1
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],1
      xor ecx,ecx
      mov cx,[Button.width]
      sub ecx,1
      add [Line.x2],ecx
      call DrawLine

      mov edx,[pointer+3]
      and edx,0xffffff
      mov [Line.color],edx

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x1],1
      xor ecx,ecx
      mov cx,[Button.width]
      sub ecx,1
      add [Line.x2],ecx
      call DrawLine

      ret

Draw2DActiveButton:

      mov edx,[colors_table1]
      and edx,0xffffff
      ;mov [Button.color2],edx

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov si,[Button.width]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],esi
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],esi
      call DrawLine

      ret

Put2DActiveButton:

      mov edx,[pointer+15*3]
      and edx,0xffffff

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov si,[Button.width]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],esi
      call DrawLine

      mov edx,[colors_table2+8*3]
      and edx,0xffffff

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],edx
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],esi
      call DrawLine

      ret

DrawPressed2DButton:

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      and [Line.color],0
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      ;mov cx,[Button.height]
      mov si,[Button.width]
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],esi
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add eax,esi
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      mov [Line.color],0xffffff
      add [Line.y2],ecx
      call DrawLine

      xor eax,eax
      xor ebx,ebx
      xor ecx,ecx
      xor esi,esi
      mov ax,[Button.x]
      mov bx,[Button.y]
      mov cx,[Button.height]
      mov si,[Button.width]
      add ebx,ecx
      mov [Line.x1],eax
      mov [Line.x2],eax
      mov [Line.y1],ebx
      mov [Line.y2],ebx
      add [Line.x2],esi
      call DrawLine

      ret

;****************************************************************
;***************Elements of menegment for Controls***************
;****************************************************************

;**********************************************************
;********************Crate control*************************
;**********************************************************

;IN
;eax - ctructure's size
;ebx - pointer to structure for parend
;OUT
;eax - pointer to new control

crate_control:

      mov [Parend],ebx

      ;get memory for structure
      call malloc

      ;add new children for parend
      mov ecx,[ebx+8]
      test ecx,ecx
      jnz have_children_for_parend
      mov esi,ebx

      mov [ControlID],1
      mov [ebx+4],eax	  ;add children as second control
      mov [ebx+8],eax	  ;add children as last control
      mov [eax+40],dword 1 ;ID for first child of parend
      mov [ebx+20],esi
      ;
      mov [eax+8],ebx
      mov [eax+20],ebx

      jmp exit_crate_control
      have_children_for_parend:

      ;save in edx current parend
      mov edx,ebx

      ;current parend ?= parend for end control
      mov ecx,[ebx+20]
      cmp ecx,edx
      je add_control_for_parend
      ;if we here than need add control for child

	 mov esi,[ebx+12]
	 test esi,esi
	 jnz control_have_child
	   ;add first child for control
	   mov [ebx+12],eax
	   mov [ebx+16],eax
	   ;save in child information about parend
	   ;save in child parend
	   mov [eax+20],ebx
	   ;save in child pointer to parend as last
	   mov [eax+8],ebx
	   ;save ID in child
	   add [ControlID],1
	   mov esi,[ControlID]
	   mov [eax+40],esi

	   jmp exit_crate_control
	 control_have_child:

	 ;get end child for control
	 mov ecx,[ebx+16]
	 ;save in end child information about new child
	 mov [ecx+4],eax
	 ;save in new control information about last control
	 mov [eax+8],ecx
	 ;save parend in child
	 mov [eax+20],ebx
	 ;save ID for new child
	 mov esi,[ControlID]
	 mov [eax+40],esi
	 ;save in parend addres end child
	 mov [ebx+16],eax

	 jmp exit_crate_control
      add_control_for_parend:

      ;find end control for this is parend
      go_find_end_control:
	mov esi,[ebx+4]
	mov ebx,esi
	mov edi,[esi+4]
	test esi,esi
	jz exit_find_end_control
      test edi,edi
      jnz go_find_end_control

      exit_find_end_control:
      ;ebx=end control for this parend

      ;calculate ID for next Control
      add [ControlID],1
      mov esi,[ControlID]

      ;put information about new control to the last control
      ;save in last control pointer to next control
      mov [ebx+4],eax
      ;save in new control pointer to last control
      mov [eax+8],ebx
      ;save parend for new control
      mov ecx,[Parend]
      mov [eax+20],ecx
      ;save ID for new control
      mov [eax+40],esi

      exit_crate_control:

      ret

;************************************************************
;***********************Destroy control**********************
;************************************************************

;Delete Control.
;IN
;pointer to control for delete
;OUT
;not returned value
align 4

destroy_control:

      mov eax,[esp+4]
      mov [PointerToControl],eax
      mov ebx,[eax+8]  ;pointer to last control
      mov ecx,[eax+4]  ;pointer to next control

      cmp ebx,ecx
      je no_change_string

      ;delete current control from string
      mov [ebx+4],ecx
      mov [ecx+8],ebx
      no_change_string:

      ;send message to control for deleting
      mov [Message],dword -1
      mov ebx,[eax] ;load .... for control
      push Message
      push eax
      call ebx

      mov eax,[PointerToControl]
      ;free memory from control
      call free

      ret 4

;***********************************************************
;*****************Send message to Control*******************
;***********************************************************

;IN
;system event(from function 10,11,23)
;pointer to parend(structure)
;OUT
;not returned value
align 4

send_message:

     ;get pointer to parend
      mov eax,[esp+4]
      mov [Parend],eax

      ;get system event
      mov eax,[esp+8]
      mov [Message],eax ;save event

      ;jmp exit_check_event_type

      ;check for event type and get parameters for Control
      dec eax
      jnz no_window_redraw

	mov ebx,[Parend]

	send_message_for_redraw_to_next_control:
	  ;get pointer to next child control
	  mov esi,[ebx+4]
	  mov ebx,esi	;ebx= pointer to next control

	  ;if esi=0 than exit
	  test esi,esi
	  jz exit_send_message_for_redraw_to_next_control

	    push ebx
	    push esi

	    mov eax,ebx
	    mov ebx,[eax] ;load .... for control
	    push Message
	    push eax
	    call ebx

	    pop esi
	    pop ebx

	  jmp send_message_for_redraw_to_next_control

	  exit_send_message_for_redraw_to_next_control:

      jmp exit_check_event_type
      no_window_redraw:

      dec eax
      jnz no_keys


	;if have active control than send message
	;checking for active control
	mov ebx,[ActiveControl]
	test ebx,ebx
	jz exit_check_event_type

	 mov eax,2
	 int 0x40

	cmp eax,1
	jne have_key
	;have't keys in buffer
	and [Message+4],dword 0
	jmp exit_check_event_type
	have_key:

	cmp al,2
	jne no_hot_keys

	mov [Message+8],dword 1
	no_hot_keys:

	shr eax,8
	mov [Message+4],eax

	mov eax,[ActiveControl]
	mov ebx,[eax] ;load .... for control
	push Message
	push eax
	call ebx

      jmp exit_check_event_type
      no_keys:

      dec eax
      jnz no_button

	;if have active control than send message
	;checking for active control
	mov eax,[ActiveControl]
	test eax,eax
	jz exit_check_event_type

	mov eax,17
	int 0x40

	cmp eax,1
	jne have_pressed_button
	;have't pressed button in buffer
	and [Message+4],dword 0
	jmp exit_check_event_type
	have_pressed_button:

	shr eax,8
	mov [Message+4],eax

	mov eax,[ActiveControl]
	mov ebx,[eax] ;load .... for control
	push Message
	push eax
	call ebx

      jmp exit_check_event_type
      no_button:

      cmp eax,3
      jne no_mouse

       ;get mouse coordinats(position from window)
	mov eax,37
	mov ebx,1
	int 0x40

	mov ebx,eax
	shr eax,16
	and ebx,0xffff
	mov [Message+4],eax ;mouse x
	mov [Message+8],ebx ;mouse y

	;which button of mouse pressed ?
	mov eax,37
	mov ebx,2
	int 0x40

	mov [Message+12],eax

	;set active control to 0
	;and [ActiveControl],dword 0

	;check childrens of parend for crossing
	mov ebx,[Parend]

	next_conrol_check_for_crossing_with_mouse:
	  ;get pointer to next child control
	  mov esi,[ebx+4]
	  mov ebx,esi	;ebx= pointer to next control

	  test esi,esi
	  jz exit_next_conrol_check_for_crossing_with_mouse

	  mov [PointerToControl],ebx

	  mov eax,[ebx+24]
	  mov [x_ctl],eax
	  mov eax,[ebx+28]
	  mov [y_ctl],eax

	  push ebx
	  push esi

	  mov ecx,[ebx+32]
	  mov edx,[ebx+36]
	  mov esi,[Message+4] ;mouse x
	  mov edi,[Message+8] ;mouse y
	  mov eax,[x_ctl]
	  mov ebx,[y_ctl]

	  call CheckCrossingBox

	  cmp eax,0xffffff
	  jne no_activate_control

	    mov eax,[ButtonsOfMouse]
	    and eax,1b
	    test eax,eax
	    jz no_activate_control

	       mov eax,[PointerToControl]
	       mov [ActiveControl],eax
	  no_activate_control:

	    mov eax,[PointerToControl]
	    mov ebx,[eax] ;load .... for control
	    push Message
	    push eax
	    call ebx

	  pop esi
	  pop ebx

	  jmp next_conrol_check_for_crossing_with_mouse

	  exit_next_conrol_check_for_crossing_with_mouse:

      no_mouse:

      exit_check_event_type:

      ret 8


;**********************************************************
;************************MENU******************************
;**********************************************************
menu:

      ;mov eax,[esp+4]
      ;mov [Pointer],eax

      mov eax,10
      mov ebx,10
      mov ecx,280
      mov edx,280
      ;mov esi,[Pointer]
      ;call SaveFonForRectangle

      ret 4


;eax -first color
;ebx- second color
;ecx- length of line
;edx- pointer to memory for colors of gradient

gradient:

      mov [length],ecx

      and eax,0xffffff
      and eax,0xffffff

      mov [b_min],al
      mov [b_max],bl
      shr eax,8
      shr ebx,8
      mov [g_min],al
      mov [g_max],bl
      shr eax,8
      shr ebx,8
      mov [r_min],al
      mov [r_max],bl

      mov eax,[length]
      dec eax
      mov [v],eax
      fild [v]

      xor eax,eax
      mov al,[r_max]
      sub al,[r_min]
      mov [v],eax
      fild [v]
      fdiv st0,st1
      fstp [step_r]

      xor eax,eax
      mov al,[g_max]
      sub al,[g_min]
      mov [v],eax
      fild [v]
      fdiv st0,st1
      fstp [step_g]

      xor eax,eax
      mov al,[b_max]
      sub al,[b_min]
      mov [v],eax
      fild [v]
      fdiv st0,st1
      fstp [step_b]

      fstp [v]

      xor eax,eax
      mov al,[r_min]
      mov [r],al
      mov [v],eax
      fild [v]
      fstp [r_f]

      xor eax,eax
      mov al,[g_min]
      mov [g],al
      mov [v],eax
      fild [v]
      fstp [g_f]

      xor eax,eax
      mov al,[b_min]
      mov [b],al
      mov [v],eax
      fild [v]
      fstp [b_f]

      next_gradient_color_save:

	xor ebx,ebx
	xor eax,eax
	mov al,[r]
	mov bl,al
	shl eax,8
	mov al,[g]
	shl eax,8
	mov al,[b]

	mov [edx],ax
	mov [edx+2],bl

	fld [step_r]
	fld [r_f]
	fadd st0,st1
	fst [r_f]
	fistp [v]
	xor eax,eax
	mov eax,[v]
	mov [r],al
	fstp [v]

	fld [step_g]
	fld [g_f]
	fadd st0,st1
	fst [g_f]
	fistp [v]
	xor eax,eax
	mov eax,[v]
	mov [g],al
	fstp [v]

	fld [step_b]
	fld [b_f]
	fadd st0,st1
	fst [b_f]
	fistp [v]
	xor eax,eax
	mov eax,[v]
	mov [b],al
	fstp [v]

	add edx,3

      dec ecx
      jnz  next_gradient_color_save

      ret


DrawLine:

      mov eax,38
      mov ebx,[Line.x1]
      mov ecx,[Line.y1]
      shl ebx,16
      shl ecx,16
      add ebx,[Line.x2]
      add ecx,[Line.y2]
      mov edx,[Line.color]
      int 0x40

      ret

DrawPixel:

      xor eax,eax
      inc al
      mov ebx,[Pixel.x]
      mov ecx,[Pixel.y]
      mov edx,[Pixel.color]
      int 0x40

      ret

RectangleContour:

      mov eax,38
      mov ebx,[Rectangle.x]
      mov ecx,[Rectangle.y]
      mov esi,ebx
      mov edi,ecx
      shl ebx,16
      shl ecx,16
      add ebx,esi
      add ecx,edi
      add ebx,[Rectangle.width]
      mov edx,[Rectangle.color]
      int 0x40

      mov eax,38
      mov ebx,[Rectangle.x]
      mov ecx,[Rectangle.y]
      add ecx,[Rectangle.height]
      mov esi,ebx
      mov edi,ecx
      shl ebx,16
      shl ecx,16
      add ebx,esi
      add ecx,edi
      add ebx,[Rectangle.width]
      mov edx,[Rectangle.color]
      int 0x40

      mov eax,38
      mov ebx,[Rectangle.x]
      mov ecx,[Rectangle.y]
      mov esi,ebx
      mov edi,ecx
      shl ebx,16
      shl ecx,16
      add ebx,esi
      add ecx,edi
      add ecx,[Rectangle.height]
      mov edx,[Rectangle.color]
      int 0x40

      mov eax,38
      mov ebx,[Rectangle.x]
      mov ecx,[Rectangle.y]
      add ebx,[Rectangle.width]
      mov esi,ebx
      mov edi,ecx
      shl ebx,16
      shl ecx,16
      add ebx,esi
      add ecx,edi
      add ecx,[Rectangle.height]
      mov edx,[Rectangle.color]
      int 0x40

      ret

;eax -first color
;ebx- second color
;OUT
;eax - averege color
calculate_average_color:

      and eax,0xffffff
      and ebx,0xffffff

      mov [b_min],al
      mov [b_max],bl
      shr eax,8
      shr ebx,8
      mov [g_min],al
      mov [g_max],bl
      shr eax,8
      shr ebx,8
      mov [r_min],al
      mov [r_max],bl

      xor eax,eax
      xor ebx,ebx
      mov al,[r_max]
      mov bl,[r_min]
      add eax,ebx
      shr eax,1
      mov [r],al

      xor eax,eax
      xor ebx,ebx
      mov al,[g_max]
      mov bl,[g_min]
      add eax,ebx
      shr eax,1
      mov [g],al

      xor eax,eax
      xor ebx,ebx
      mov al,[b_max]
      mov bl,[b_min]
      add eax,ebx
      shr eax,1
      mov [b],al

      xor eax,eax
      mov al,[r]
      shl eax,8
      mov al,[g]
      shl eax,8
      mov al,[b]

      ret

;eax -color
;ebx- sub value
;OUT
;eax - sabved color
calculate_sabved_color:

      and eax,0xffffff

      mov [b],al
      shr eax,8
      mov [g],al
      shr eax,8
      mov [r],al

      sub [r],bl
      sub [g],bl
      sub [b],bl

      xor eax,eax
      mov al,[r]
      shl eax,8
      mov al,[g]
      shl eax,8
      mov al,[b]

      ret

DrawString:

      call GetLengthString
      mov esi,eax

      mov eax,4
      mov ebx,[Font.x]
      shl ebx,16
      add ebx,[Font.y]
      mov ecx,[Button.textcolor]
      mov edx,[Button.text]
      int 0x40

      ret

;ebx - pointer to string
GetLengthString:

      mov ebx,[Button.text]
      xor ecx,ecx

      next_simvol:
	inc ecx
	xor eax,eax
	mov al,[ebx]
	test al,al
	jz null
	inc ebx
       jmp next_simvol

      null:
      mov eax,ecx
      dec eax

      ret

;eax - x1
;ebx - y1
;ecx - size x
;edx - size y
;esi - x2
;edi - y2
;if crossing than eax=0xffffff

CheckCrossingBox:

      add ecx,eax
      add edx,ebx

      cmp esi,eax
      jl exit_crossing
      cmp esi,ecx
      ja exit_crossing
      cmp edi,ebx
      jl exit_crossing
      cmp edi,edx
      ja exit_crossing
      xor eax,eax
      mov eax,0xffffff
      exit_crossing:

      ret

;eax - x
;ebx - y
;ecx - size x
;edx - size y
;esi - pointer to memory for rectangle
SaveFonForRectangle:

     mov [Rectangle.x],eax
     mov [Rectangle.y],ebx
     mov [Rectangle.width],ecx
     mov [Rectangle.height],edx
     mov [PointerToMem],esi

     ;get bytes per string
     mov eax,61
     mov ebx,2
     int 0x40
     mov [BitsPerPixel],eax

     mov eax,61
     mov ebx,3
     int 0x40
     mov [BytesPerString],eax


     ;get window coordinats
     mov eax,9
     mov ebx,IPC_table
     or ecx,-1
     int 0x40

     mov eax,dword[IPC_table+34]
     mov ebx,dword[IPC_table+38]
     ;mov ecx,dword[IPC_table+42]
     ;mov edx,dword[IPC_table+46]
     ;mov [WindowCoordinatX],eax
     ;mov [WindowCoordinatY],ebx
     ;mov [WindowSizeX],ecx
     ;mov [WindowSizeY],edx

     add eax,[Rectangle.x]
     add ebx,[Rectangle.y]

     imul ebx,[BytesPerString]
     mov esi,[Rectangle.width]

     cmp [BitsPerPixel],24
     jne no_24

     lea eax,[eax+eax*2]
     lea esi,[esi+esi*2]
     mov edi,3
     jmp exit_bits_per_pixel
     no_24:

     shl eax,2
     shl esi,2
     mov edi,4
     exit_bits_per_pixel:

     add eax,ebx

     mov ebx,[BytesPerString]
     sub ebx,esi
     mov [offset],ebx

     mov esi,[PointerToMem]
     mov edx,[Rectangle.height]
     next_string_pixels_save:

       mov ecx,[Rectangle.width]
       next_pixel_save:

	 mov ebx,[gs:eax]
	 and ebx,0xffffff
	 mov [esi],bx
	 shr ebx,16
	 mov [esi+2],bl

	 add esi,3
	 add eax,edi
       dec ecx
       jnz next_pixel_save

       add eax,[offset]
     dec edx
     jnz next_string_pixels_save

     exit_:
     ret

;eax - size
;OUT
;eax - pointer
malloc:

      push ebx
      push ecx

      mov ecx,eax
      mov eax,68
      mov ebx,12
      int 0x40

      pop ecx
      pop ebx

      ret

;eax - pointer
free:
      push ebx
      push ecx

      mov ecx,eax
      mov eax,68
      mov ebx,13
      int 0x40

      pop ecx
      pop ebx

      ret


align 16
EXPORTS:
		   dd szDestroyControl,destroy_control
		   dd szSendMessage,send_message
		   dd szCrateButton,crate_button
		   dd szCrateScroler,crate_scroler
		   dd szCrateZakladka,crate_zakladka
		   dd szCrateImage,crate_image
		   dd szCrateText,crate_text
		   dd szCrateNumber,crate_number
		   dd 0

szDestroyControl   db 'destroy control',0
szSendMessage	   db 'send message',0
szCrateButton	   db 'crate button',0
szCrateScroler	   db 'crate scroler',0
szCrateZakladka    db 'crate zakladka',0
szCrateImage	   db 'crate image',0
szCrateText	   db 'crate text',0
szCrateNumber	   db 'crate number',0

section '.data' data readable writable align 16
;************************************************
;******************DLL DATA**********************
;************************************************

;ScreenSizeX               rd 1
;ScreenSizeY               rd 1

BitsPerPixel		  rd 1
BytesPerString		  rd 1
WindowCoordinatX	  rd 1
WindowCoordinatY	  rd 1
WindowSizeX		  rd 1
WindowSizeY		  rd 1

PointerToMem		  rd 1
offset			  rd 1

v			  rd 1
v2			  rd 1

r_min			  rb 1
r_max			  rb 1
g_min			  rb 1
g_max			  rb 1
b_min			  rb 1
b_max			  rb 1
r			  rb 1
g			  rb 1
b			  rb 1
r_f			  rd 1
g_f			  rd 1
b_f			  rd 1
step_r			  rd 1
step_g			  rd 1
step_b			  rd 1
length			  rd 1
length2 		  rd 1
Color			  rd 1
AveregeColor		  rd 1

line_coordinat_x	  rd 1
line_coordinat_y	  rd 1
line_size_x		  rd 1
line_size_y		  rd 1
line_size_y_f		  rd 1

x			  rd 1
y			  rd 1
xo			  rd 1
yo			  rd 1
x_ctl			  rd 1
y_ctl			  rd 1

ReturnAddresButton	  rd 1
ReturnAddresScroler	  rd 1
ReturnAddresZakladka	  rd 1
ReturnAddresImage	  rd 1
ReturnAddresText	  rd 1
ReturnAddresNumber	  rd 1

Button_Flag		  rb 1

ScrolerSize		  rd 1
ControlID		  rd 1
Message 		  rd 4
Parend			  rd 1
PointerToControl	  rd 1
ActiveControl		  rd 1
ButtonsOfMouse		  rd 1

PointerToStructureForZakladka rd 1
ParendForZakladka	      rd 1
PointerToStructureForButton   rd 1
ParendForButton 	      rd 1
PointerToStructureForScroler  rd 1
ParendForScroler	      rd 1
PointerToStructureForImage    rd 1
ParendForImage		      rd 1
PointerToStructureForText     rd 1
ParendForText		      rd 1
PointerToStructureForNumber   rd 1
ParendForNumber 	      rd 1

PointerForButton	      rd 1
PointerForScroler	      rd 1
PointerForZakladka	      rd 1
PointerForImage 	      rd 1
PointerForText		      rd 1
PointerForNumber	      rd 1

ChisloZakladok		      rd 1

;*********************************
;**********GUI structures*********
;*********************************

;struc CONTROL
;{
; .ctrl_proc        rd 0
; .ctrl_fd          rd 0
; .ctrl_bk          rd 0
; .child_fd         rd 0
; .child_bk         rd 0
; .parend           rd 0
; .x                rd 0
; .y                rd 0
; .sizex            rd 0
; .sizey            rd 0
; .ID               rd 0
;}

struc BUTTON
{
 .ctrl_proc	   rd 1
 .ctrl_fd	   rd 1
 .ctrl_bk	   rd 1
 .child_fd	   rd 1
 .child_bk	   rd 1
 .parend	   rd 1
 .ctrl_x	   rd 1
 .ctrl_y	   rd 1
 .ctrl_sizex	   rd 1
 .ctrl_sizey	   rd 1
 .ctrl_ID	   rd 1

 .type		   rb 1
 .flag		   rb 1
 .x		   rw 1
 .y		   rw 1
 .width 	   rw 1
 .height	   rw 1
 .image 	   rd 1
 .imageX	   rw 1
 .imageY	   rw 1
 .imageSizeX	   rw 1
 .imageSizeY	   rw 1
 .transparentColor rd 1
 .text		   rd 1
 .textX 	   rw 1
 .textY 	   rw 1
 .textcolor	   rd 1
 .color1	   rd 1
 .color2	   rd 1
 .mouseX	   rw 1
 .mouseY	   rw 1
}

struc SCROLER
{
 .ctrl_proc	   rd 1
 .ctrl_fd	   rd 1
 .ctrl_bk	   rd 1
 .child_fd	   rd 1
 .child_bk	   rd 1
 .parend	   rd 1
 .ctrl_x	   rd 1
 .ctrl_y	   rd 1
 .ctrl_sizex	   rd 1
 .ctrl_sizey	   rd 1
 .ctrl_ID	   rd 1

 .type		   rb 1
 .x		   rw 1
 .y		   rw 1
 .length	   rw 1
 .color1	   rd 1
 .size		   rd 1
 .pos		   rd 1
 .mouseX	   rw 1
 .mouseY	   rw 1
}

;********************************
;*********Child Buttons**********
;********************************
struc CHILDBUTTON
{
 .type		   rb 1
 .flag		   rb 1
 .x		   rw 1
 .y		   rw 1
 .width 	   rw 1
 .height	   rw 1
 .image 	   rd 1
 .imageX	   rw 1
 .imageY	   rw 1
 .imageSizeX	   rw 1
 .imageSizeY	   rw 1
 .transparentColor rd 1
 .text		   rd 1
 .textX 	   rw 1
 .textY 	   rw 1
 .textcolor	   rd 1
 .color1	   rd 1
 .color2	   rd 1
 .mouseX	   rw 1
 .mouseY	   rw 1
}

;********************************
;*Graphics primitives structures*
;********************************
struc LINE
{
 .x1		   rd 1
 .y1		   rd 1
 .x2		   rd 1
 .y2		   rd 1
 .color 	   rd 1
}

struc PIXEL
{
 .x		   rd 1
 .y		   rd 1
 .color 	   rd 1
}

struc FONT1
{
 .sizeX 	   rd 6
 .sizeY 	   rd 9
 .x		   rd 1
 .y		   rd 1
}

struc RECTANGLE
{
 .x		   rd 1
 .y		   rd 1
 .width 	   rd 1
 .height	   rd 1
 .color 	   rd 1
}

struc SCROLLBAR
{
 .x		   rd 1
 .y		   rd 1
}

struc ZAKLADKA
{
 .type				rb 1
 .flag				rb 1
 .x				rd 1
 .y				rd 1
 .sizex 			rd 1
 .sizey 			rd 1
 .color1			rd 1
 .color2			rd 1

 .FullZakladkaSizeX		rd 1
 .ZakladkaSizeX 		rd 1
 .PointerToTextForZakladka	rd 1
 .ZakladkaX			rd 1
 .ZakladkaY			rd 1
 .ChildButtonsForZakladka	rd 1
 .CounterChildButtons		rd 1
 .ChisloZakladok		rd 1
 .ChisloStrokeZakladok		rd 1
 .MessageForChildButton 	rd 5
 .ChildControlForZakladka	rd 1
 .NumberZakladkasInActiveString rd 1
 .NumberZakladkasInEndString	rd 1
 .PointerToActiveZakladkas	rd 1
 .PointerToEndZakladkas 	rd 1
 .ZakladkaFlag			rb 1
 .y_end_stroke			rd 1

 .CounterChildControls		rd 1
 .ActiveChildControl		rd 1
 .AddresOfActiveChildControl	rd 1
 .MouseX			rd 1
 .MouseY			rd 1

 .DefectSizeX			rd 1
 .ControlAddres 		rd 1

 .counter1			rd 1
 .counter2			rd 1

 .NumberActiveControl		rd 1

 .WorkPlace_x			rd 1
 .WorkPlace_y			rd 1
 .WorkPlace_sizex		rd 1
 .WorkPlace_sizey		rd 1
 .WorkPlace_windowx		rd 1
 .WorkPlace_windowsizex 	rd 1

}

struc IMAGE
{
 .type				rb 1
 .flag				rb 1
 .color 			rd 1
 .x				rd 1
 .y				rd 1
 .sizex 			rd 1
 .sizey 			rd 1
 .pointer			rd 1
}

struc TEXT
{
 .type				rb 1
 .flag				rb 1
 .color 			rd 1
 .x				rd 1
 .y				rd 1
 .length			rd 1
 .pointer			rd 1
}

struc NUMBER
{
  .type 			rb 1
  .flag 			rb 1
  .color			rd 1
  .x				rd 1
  .y				rd 1
  .number			rd 1
  .parameters			rd 1
}

Button		   BUTTON
Scroler 	   SCROLER

Line		   LINE
Pixel		   PIXEL
Font		   FONT1
Rectangle	   RECTANGLE
ScrollBar	   SCROLLBAR

ChildButton	   CHILDBUTTON
Zakladka	   ZAKLADKA
Image		   IMAGE
Text		   TEXT
Number		   NUMBER

pointer 		  rd 50
pointer2		  rd 13
IPC_table		  rb 1024
colors_table1		  rd 15
colors_table2		  rd 15
